;/***************************************************************************
;
;			   PDC Prolog
;
;		  Basic Runtime Support Functions
;
; FileName: MSC2MTIN.ASM
; PURPOSE: OS2 _main replacement for linking with MicroSoft C.
;
; This file implements the _main routine called by Microsofts start-up
; code. _main starts thread 2 to run _cmain - which in every respect
; is a replacement for _main - and waits for a semaphore to clear.
; The command-line parameters passed to _main are passed on to _cmain.
;
; 
;  Date Modified, By,    Comments.
; 
;                      
;***************************************************************************/

TITLE	INIT - Initiate execution of a PROLOG program from C
SUBTTL	Copyright 1987,90 by Prolog Development Center
NAME	MSC2MTIN

.286P


;
;---------------------- Define PDC Prolog Segments ---------------------------
;

; Prepare the layout of an array of module descriptors
; one record is generated for each module
public _PROLOG_ModTab
PROMOD	SEGMENT BYTE PUBLIC 'PROMOD'
_PROLOG_ModTab	label	byte
PROMOD	ENDS

; The array of module descriptors will be ended with a zero
PROMODE	SEGMENT BYTE PUBLIC 'PROMOD'
	dd 0
PROMODE	ENDS

MODGROUP GROUP PROMOD,PROMODE

; The array of module descriptors will be ended with a zero
PROSYMB SEGMENT PARA COMMON 'PROSYMB'
PROSYMB	ENDS

;
;-----------------------------------------------------------------------------
;

INCL_DOSINFOSEG equ 1

;If you have the include-file bsedos.inc, preferably use that one if
;assembling this file. Otherwise, the offset required to address the
;pid of this process in the local information segment is 0 (line 156 below).

include c:\pmsdk\include\bsedos.inc

MINSTACK equ 9600

extrn	__stklen: word

_DATA	SEGMENT word PUBLIC 'DATA'
Thrd1Sem	dd ?		; Thrd1 waits for this one.
retcode		dw ?
SemName		db '\SEM\PSYS\MTD00000',0
SemNameEnd	= $-2
_DATA	ENDS

STACKVARS segment word public
STACKVARS ends

DGROUP GROUP _DATA

; STACKVARS
extrn	_PFP_Err: byte		; Prolog floating point error.
extrn	_CPU_Type: byte		; 286/386;0==I8086; take care if changing
extrn	_BRK_BreakEnabled: byte	; Break enabled.
extrn	_BRK_BreakPressed: byte	; Break pressed.
extrn	_INIT_DataSeg: word	; Real dataseg.
extrn	_INIT_endstackv: abs

extrn	_Thrd2StackSel: word
extrn	_cmain: far

;int far cdecl __beginthread (void (cdecl far *) (void far *), void far *,
;							unsigned, void far *);
extrn	__beginthread: far
extrn	__exit: far

extrn	__linfoseg: word

extrn   DosAllocSeg:far
extrn	DosReallocSeg:far
extrn   DosExit:far
extrn   DosSleep:far
extrn	DosCreateSem: far
extrn	DosSemSet: far
extrn	DosSemWait: far
extrn	DosSemClear: far


RUNPMAIN_TEXT segment byte public 'CODE'
assume ds:dgroup,cs:runpmain_text

public _main
_main label far
public _PROLOG_Main
_PROLOG_Main proc far

	push	bp
	mov	bp,sp
;
; Get the requested stack size in AX.
; Zero(0) length will mean use a full 64k stack.
;
	mov	ax,__stklen
	cmp	ax,MINSTACK		; No, is it enough then?
	jae	ClipAndGo		; Yes, it's enough.
	mov	ax,MINSTACK		; No, it wasn't, force it to be.
	mov	__stklen,ax		; Override requested size

ClipAndGo LABEL NEAR
	and	al,0FEH			; Make requested stack size even.
	push	ax

	push	seg _Thrd2StackSel
	push	offset _Thrd2StackSel
	push	0			; Alloc flags: strictly non-sharing.
	call	DOSALLOCSEG

	or	ax,ax			; Was there a problem?
	jz	cont1			; No, carry on.
	jmp	InitFailed

cont1:
	push	ds			; Keep ds on stack.
	push	seg _Thrd2StackSel
	pop	es
	mov	es,es:_Thrd2StackSel
	push	STACKVARS
	pop	ds
	mov	cx,_INIT_endstackv
	shr	cx,1			; Probably < 256 bytes.
	xor	si,si
	xor	di,di			; Copy initialized stack-vars to
	rep	movsw			; new stack segment.
	pop	es			; DS, kept over from above, into ES.

	mov	di,offset SemNameEnd
	std
	mov	ds,es:[__linfoseg]	; Now cat PID onto semname.
	mov	ax,ds:[linfoseg.lis_pidCurrent]; ds:[0]
	push	es
	pop	ds			; Restore ds.
	mov	bx,10			; Divisor.

loopy:
	xor	dx,dx
	div	bx			; Result in AX, remainder in DX.
	xchg	ax,dx			; Result in DX, remainder in AX.
	add	al,'0'			; ASCII equivalent of remainder.
	stosb
	xchg	ax,dx
	or	ax,ax
	jnz	loopy
	cld

	push	0			; Private semaphore ownership.
	push	ds
	push	offset Thrd1Sem
	push	ds
	push	offset SemName
	call	DosCreateSem
	or	ax,ax
	jnz	InitFailed

;  __beginthread(MainThread,MK_FP(Thrd2StackSel,INIT_endstackv),
;					_stklen-=INIT_endstackv,&argc);
	push	ss			; Fake arguments to MainThread.
	lea	ax,[bp+6]
	push	ax
	sub	__stklen,_INIT_endstackv
	push	__stklen
	push	seg _Thrd2StackSel
	pop	es
	push	es:[_Thrd2StackSel]
	push	_INIT_endstackv
	push	cs
	push	offset MainThread
	call	far ptr __beginthread
	add	sp,14
	cmp	ax,-1			; ax == -1 => bombed out;
	je	InitFailed		; ax != -1 == thread id, ignore.

WaitSem:
	push	ds
	push	offset Thrd1Sem
	mov	ax,-1
	push	ax
	push	ax
	call	DosSemWait
	mov	ax,retcode

InitFailed:
	mov	sp,bp
	pop	bp
	retf

_PROLOG_Main endp


; UNSIGNED cdecl MainThread(void * PtrToArgc)
; CHAR **envp;
; CHAR **argv;
; UNSIGNED argc;

MainThread proc far
ptrtoargc equ 6
argc equ -10
argv equ -8
envp equ -4

	enter	10,0
	push	ds			; Copy argc, argv and envp passed
	lds	si,[bp+ptrtoargc]	; as arguments to _main to local
	push	ss			; variables on the stack.
	pop	es
	lea	di,[bp+argc]
	mov	cx,5
	rep	movsw
	pop	ds

no_args:
	mov	word ptr ss:_INIT_DataSeg,seg _Thrd2StackSel
	call	_cmain			; Local vars are args for _cmain.
	mov	retcode,ax
	push	ds
	push	offset Thrd1Sem
	call	DosSemClear
	leave
	retf
MainThread endp

RUNPMAIN_TEXT ends

END
