/************************************************************************
	REF0PRO.PRO
	
	Illustrates accessing a reference variable in C
	 when the reference varable is bound, this is recorded in 
	 the TRAIL so that it may be properly unbound on backtracking

	See REF0C.C
	
	Copyright (c) 1986, 1990 by Prolog Development Center
************************************************************************/

project "ref0"

GLOBAL DOMAINS
	int = reference integer

GLOBAL PREDICATES
	inst_refvar(int,integer) - (i,i) language C

PREDICATES
	tester(int)
	free_int(int)

CLAUSES
	tester(X):- inst_refvar(X,5), write(X,'\n'), fail.
	tester(X):- write(X,'\n').

	free_int(_).

GOAL
        
        free_int(X), 
        tester(X).
