/************************************************************************
	SPREDS.H

   PDC-PROLOG STANDARD PREDICATES

	Copyright (c) 1990 Prolog Development Center
************************************************************************/

#define FNO         unsigned char
#define string      char*
#define dbref       unsigned long
#define prfile      FNO*
#define bt_selector int
#define db_selector FNO*
#define place       FNO*
#define access      FNO*
#define deny        FNO*
#define pro_regs    void*
#define bgi_ilist   void*


/* exit() -- () */
#define exit RUN_ExitZero
extern void exit(void);


/* exit(integer) -- (i) */
#define exit_1 RUN_Exit
extern void exit_1(unsigned int);


/* nl() -- () */
#define nl IO_Nl
extern void nl(void);


/* beep() -- () */
#define beep OS_Beep
extern void beep(void);


/* upper_lower(string,string) -- (i,i) */
#define upper_lower CONV_up_low_ii
extern void upper_lower(string, string);


/* upper_lower(string,string) -- (i,o) */
#define upper_lower_1 CONV_up_low_io
extern void upper_lower_1(string, string*);


/* upper_lower(string,string) -- (o,i) */
#define upper_lower_2 CONV_up_low_oi
extern void upper_lower_2(string*, string);


/* upper_lower(char,char) -- (i,i) */
#define upper_lower_3 CONV_UpLowCh_ii
extern void upper_lower_3(char, char);


/* upper_lower(char,char) -- (i,o) */
#define upper_lower_4 CONV_UpLowCh_io
extern void upper_lower_4(char, char*);


/* upper_lower(char,char) -- (o,i) */
#define upper_lower_5 CONV_UpLowCh_oi
extern void upper_lower_5(char*, char);


/* getbacktrack(integer) -- (o) */
#define getbacktrack RUN_BTop_o
extern void getbacktrack(int*);


/* cutbacktrack(integer) -- (i) */
#define cutbacktrack RUN_BTop_i
extern void cutbacktrack(int);


/* inkey(char) -- (o) */
#define inkey KB_InKey
extern void inkey(char*);


/* keypressed() -- () */
#define keypressed KB_KeyPressed
extern void keypressed(void);


/* unreadchar(char) -- (i) */
#define unreadchar KB_UnRdCh_i
extern void unreadchar(char);


/* readchar(char) -- (o) */
#define readchar IO_RdCh
extern void readchar(char*);


/* readln(string) -- (o) */
#define readln IO_RdLine
extern void readln(string*);


/* readreal(real) -- (o) */
#define readreal IO_RdReal
extern void readreal(double*);


/* readint(integer) -- (o) */
#define readint IO_RdIntg
extern void readint(int*);


/* openread(file,string) -- (i,i) */
#define openread IO_O_Read
extern void openread(prfile, string);


/* openwrite(file,string) -- (i,i) */
#define openwrite IO_O_Write
extern void openwrite(prfile, string);


/* openappend(file,string) -- (i,i) */
#define openappend IO_O_App
extern void openappend(prfile, string);


/* openmodify(file,string) -- (i,i) */
#define openmodify IO_O_Mod
extern void openmodify(prfile, string);


/* readdevice(file) -- (i) */
#define readdevice IO_RdDev_i
extern void readdevice(prfile);


/* readdevice(file) -- (o) */
#define readdevice_1 IO_RdDev_o
extern void readdevice_1(prfile*);


/* writedevice(file) -- (i) */
#define writedevice IO_WrDev_i
extern void writedevice(prfile);


/* writedevice(file) -- (o) */
#define writedevice_1 IO_WrDev_o
extern void writedevice_1(prfile*);


/* openfile(file,string,integer,integer,integer) -- (i,i,i,i,i)*/
#define openfile IO_Open
extern void openfile(prfile, string, int, int, int);


/* closefile(file) -- (i) */
#define closefile IO_Close
extern void closefile(prfile);


/* filepos(file,real,integer) -- (i,i,i) */
#define filepos IO_FSeek_i
extern void filepos(prfile, double, int);


/* filepos(file,real,integer) -- (i,o,i) */
#define filepos_1 IO_FSeek_o
extern void filepos_1(prfile, double*, int);


/* filemode(file,integer) -- (i,i) */
#define filemode IO_FileMode_i
extern void filemode(prfile, int);


/* filemode(file,integer) -- (i,o) */
#define filemode_1 IO_FileMode_o
extern void filemode_1(prfile, int*);


/* setfilesize(file) -- (i) */
#define setfilesize IO_SetFileSize
extern void setfilesize(prfile);


/* eof(file) -- (i) */
#define eof IO_Eof
extern void eof(prfile);


/* flush(file) -- (i) */
#define flush IO_Flush
extern void flush(prfile);


/* readblock(integer,string) -- (i,o) */
#define readblock IO_RdBlock
extern void readblock(int, string*);


/* writeblock(integer,string) -- (i,i) */
#define writeblock IO_WrBlock
extern void writeblock(int, string);


/* file_str(string,string) -- (i,o) */
#define file_str IO_RdFile
extern void file_str(string, string*);


/* file_str(string,string) -- (i,i) */
#define file_str_1 IO_WrFile
extern void file_str_1(string, string);


/* existfile(string) -- (i) */
#define existfile IO_Exist
extern void existfile(string);


/* deletefile(string) -- (i) */
#define deletefile OS_Unlink
extern void deletefile(string);


/* renamefile(string,string) -- (i,i) */
#define renamefile OS_Rename
extern void renamefile(string, string);


/* mkdir(string) -- (i) */
#define mkdir OS_MkDir
extern void mkdir(string);


/* rmdir(string) -- (i) */
#define rmdir OS_RmDir
extern void rmdir(string);


/* copyfile(string,string) -- (i,i) */
#define copyfile OS_CopyFile
extern void copyfile(string, string);


/* disk(string) -- (i) */
#define disk IO_Disk_i
extern void disk(string);


/* disk(string) -- (o) */
#define disk_1 IO_Disk_o
extern void disk_1(string*);


/* searchfile(string,string,string) -- (i,i,o) */
#define searchfile FNM_SearchFile_iio
extern void searchfile(string, string, string*);


/* filenamepath(string,string,string) -- (i,o,o) */
#define filenamepath FNM_FileNamePath_ioo
extern void filenamepath(string, string*, string*);


/* filenamepath(string,string,string) -- (o,i,i) */
#define filenamepath_1 FNM_FileNamePath_oii
extern void filenamepath_1(string*, string, string);


/* filenameext(string,string,string) -- (i,o,o) */
#define filenameext FNM_FileNameExt_ioo
extern void filenameext(string, string*, string*);


/* filenameext(string,string,string) -- (o,i,i) */
#define filenameext_1 FNM_FileNameExt_oii
extern void filenameext_1(string*, string, string);


/* scr_attr(integer,integer,integer) -- (i,i,i) */
#define scr_attr SCR_ScrAttr_i
extern void scr_attr(int, int, int);


/* scr_attr(integer,integer,integer) -- (i,i,o) */
#define scr_attr_1 SCR_ScrAttr_o
extern void scr_attr_1(int, int, int*);


/* field_str(integer,integer,integer,string) -- (i,i,i,i) */
#define field_str SCR_FieldString_i
extern void field_str(int, int, int, string);


/* field_str(integer,integer,integer,string) -- (i,i,i,o) */
#define field_str_1 SCR_FieldString_o
extern void field_str_1(int, int, int, string*);


/* field_attr(integer,integer,integer,integer) -- (i,i,i,i) */
#define field_attr SCR_FieldAttr_i
extern void field_attr(int, int, int, int);


/* field_attr(integer,integer,integer,integer) -- (i,i,i,o) */
#define field_attr_1 SCR_FieldAttr_o
extern void field_attr_1(int, int, int, int*);


/* scr_char(integer,integer,char) -- (i,i,i) */
#define scr_char SCR_ScrChar_i
extern void scr_char(int, int, char);


/* scr_char(integer,integer,char) -- (i,i,o) */
#define scr_char_1 SCR_ScrChar_o
extern void scr_char_1(int, int, char*);


/* textmode(integer,integer) -- (i,i) */
#define textmode SCR_TextMode_i
extern void textmode(int, int);


/* textmode(integer,integer) -- (o,o) */
#define textmode_1 SCR_TextMode_o
extern void textmode_1(int*, int*);


/* cursor(integer,integer) -- (i,i) */
#define cursor SCR_Cursor_i
extern void cursor(int, int);


/* cursor(integer,integer) -- (o,o) */
#define cursor_1 SCR_Cursor_o
extern void cursor_1(int*, int*);


/* cursorstate(string) -- (i) */
#define cursorstate SCR_CursorState
extern void cursorstate(string);


/* cursorsync() -- () */
#define cursorsync SCR_CursorSyncPsys
extern void cursorsync(void);


/* scroll(integer,integer) -- (i,i) */
#define scroll SCR_Scroll
extern void scroll(int, int);


/* cursorform(integer,integer) -- (i,i) */
#define cursorform SCR_CursorForm_i
extern void cursorform(int, int);


/* cursorform(integer,integer) -- (o,o) */
#define cursorform_1 SCR_CursorForm_o
extern void cursorform_1(int*, int*);


/* snowcheck(string) -- (i) */
#define snowcheck SCR_SnowChk_i
extern void snowcheck(string);


/* snowcheck(string) -- (o) */
#define snowcheck_1 SCR_SnowChk_o
extern void snowcheck_1(string*);


/* clearwindow() -- () */
#define clearwindow SCR_ClEntScreen
extern void clearwindow(void);


/* window_str(string) -- (i) */
#define window_str SCR_WindowStr_i
extern void window_str(string);


/* window_str(string) -- (o) */
#define window_str_1 SCR_WindowStr_o
extern void window_str_1(string*);


/* window_str(integer,integer,string) -- (i,i,i) */
#define window_str_2 SCR_WindowStrOffset
extern void window_str_2(int, int, string);


/* window_attr(integer) -- (i) */
#define window_attr SCR_WindowAttr
extern void window_attr(int);


/* attribute(integer) -- (i) */
#define attribute SCR_Attr_i
extern void attribute(int);


/* attribute(integer) -- (o) */
#define attribute_1 SCR_Attr_o
extern void attribute_1(int*);


/* expandwindow() -- () */
#define expandwindow WD_ExpCoord
extern void expandwindow(void);


/* compresswindow() -- () */
#define compresswindow WD_CompCoord
extern void compresswindow(void);


/*makewindow(integer,integer,integer,string,integer,integer,integer,integer)-- (i,i,i,i,i,i,i,i) */
#define makewindow WD_Make_8i
extern void makewindow(int, int, int, string, int, int, int,int);


/*makewindow(integer,integer,integer,string,integer,integer,integer,integer)-- (o,o,o,o,o,o,o,o) */
#define makewindow_1 WD_Make_8o
extern void makewindow_1(int*, int*, int*, string*, int*, int*, int*, int*);


/*makewindow(integer,integer,integer,string,integer,integer,integer,integer,integer,integer,string)-- (i,i,i,i,i,i,i,i,i,i,i) */
#define makewindow_2 WD_Make_11i
extern void makewindow_2(int, int, int, string, int, int, int,int, int, int, string);


/*makewindow(integer,integer,integer,string,integer,integer,integer,integer,integer,integer,string)-- (o,o,o,o,o,o,o,o,o,o,o) */
#define makewindow_3 WD_Make_11o
extern void makewindow_3(int*, int*, int*, string*, int*, int*,int*, int*, int*, int*, string*);


/* shiftwindow(integer) -- (i) */
#define shiftwindow WD_Shift_i
extern void shiftwindow(int);


/* shiftwindow(integer) -- (o) */
#define shiftwindow_1 WD_Shift_o
extern void shiftwindow_1(int*);


/* gotowindow(integer) -- (i) */
#define gotowindow WD_Goto_i
extern void gotowindow(int);


/* removewindow() -- () */
#define removewindow WD_Close_i
extern void removewindow(void);


/* removewindow(integer,integer) -- (i,i) */
#define removewindow_1 WD_Close_2i
extern void removewindow_1(int, int);


/* removeallwd() -- () */
#define removeallwd WD_CloseAll
extern void removeallwd(void);


/* framewindow(integer,string,integer,string) -- (i,i,i,i) */
#define framewindow WD_Frame_4i
extern void framewindow(int, string, int, string);


/* framewindow(integer) -- (i) */
#define framewindow_1 WD_Frame_1i
extern void framewindow_1(int);


/* existwindow(integer) -- (i) */
#define existwindow WD_Exist_i
extern void existwindow(int);


/* resizewindow() -- () */
#define resizewindow WD_Resize_i
extern void resizewindow(void);


/* resizewindow(integer,integer,integer,integer) -- (i,i,i,i) */
#define resizewindow_1 WD_Resize_4i
extern void resizewindow_1(int, int, int, int);


/* colorsetup(integer) -- (i) */
#define colorsetup WD_ColorZUp_i
extern void colorsetup(int);


/* frontchar(string,char,string) -- (i,o,o) */
#define frontchar PSTR_ft_ioo
extern void frontchar(string, char*, string*);


/* frontchar(string,char,string) -- (i,i,o) */
#define frontchar_1 PSTR_ft_iio
extern void frontchar_1(string, char, string*);


/* frontchar(string,char,string) -- (i,o,i) */
#define frontchar_2 PSTR_ft_ioi
extern void frontchar_2(string, char*, string);


/* frontchar(string,char,string) -- (i,i,i) */
#define frontchar_3 PSTR_ft_iii
extern void frontchar_3(string, char, string);


/* frontchar(string,char,string) -- (o,i,i) */
#define frontchar_4 PSTR_ft_oii
extern void frontchar_4(string*, char, string);


/* fronttoken(string,string,string) -- (i,o,o) */
#define fronttoken PSTR_fr_tok_ioo
extern void fronttoken(string, string*, string*);


/* fronttoken(string,string,string) -- (i,i,o) */
#define fronttoken_1 PSTR_fr_tok_iio
extern void fronttoken_1(string, string, string*);


/* fronttoken(string,string,string) -- (i,o,i) */
#define fronttoken_2 PSTR_fr_tok_ioi
extern void fronttoken_2(string, string*, string);


/* fronttoken(string,string,string) -- (i,i,i) */
#define fronttoken_3 PSTR_fr_tok_iii
extern void fronttoken_3(string, string, string);


/* fronttoken(string,string,string) -- (o,i,i) */
#define fronttoken_4 PSTR_fr_tok_oii
extern void fronttoken_4(string*, string, string);


/* frontstr(integer,string,string,string) -- (i,i,o,o) */
#define frontstr PSTR_fr_str
extern void frontstr(int, string, string*, string*);


/* concat(string,string,string) -- (i,i,o) */
#define concat PSTR_con_iio
extern void concat(string, string, string*);


/* concat(string,string,string) -- (i,o,i) */
#define concat_1 PSTR_con_ioi
extern void concat_1(string, string*, string);


/* concat(string,string,string) -- (o,i,i) */
#define concat_2 PSTR_con_oii
extern void concat_2(string*, string, string);


/* concat(string,string,string) -- (i,i,i) */
#define concat_3 PSTR_con_iii
extern void concat_3(string, string, string);


/* str_len(string,integer) -- (i,i) */
#define str_len PSTR_str_l_ii
extern void str_len(string, int);


/* str_len(string,integer) -- (o,i) */
#define str_len_1 PSTR_str_l_oi
extern void str_len_1(string*, int);


/* str_len(string,integer) -- (i,o) */
#define str_len_2 PSTR_str_l_io
extern void str_len_2(string, int*);


/* isname(string) -- (i) */
#define isname PSTR_is_name
extern void isname(string);


/* substring(string,integer,integer,string) -- (i,i,i,o) */
#define substring PSTR_SubStr
extern void substring(string, int, int, string*);


/* subchar(string,integer,char) -- (i,i,o) */
#define subchar PSTR_SubChar
extern void subchar(string, int, char*);


/* searchstring(string,string,integer) -- (i,i,o) */
#define searchstring PSTR_SearchStr
extern void searchstring(string, string, int*);


/* searchchar(string,char,integer) -- (i,i,o) */
#define searchchar PSTR_SearchChar
extern void searchchar(string, char, int*);


/* char_int(char,integer) -- (i,o) */
#define char_int CONV_c_i_io
extern void char_int(char, int*);


/* char_int(char,integer) -- (o,i) */
#define char_int_1 CONV_c_i_oi
extern void char_int_1(char*, int);


/* char_int(char,integer) -- (i,i) */
#define char_int_2 CONV_c_i_ii
extern void char_int_2(char, int);


/* str_int(string,integer) -- (i,o) */
#define str_int CONV_s_i_io
extern void str_int(string, int*);


/* str_int(string,integer) -- (o,i) */
#define str_int_1 CONV_s_i_oi
extern void str_int_1(string*, int);


/* str_int(string,integer) -- (i,i) */
#define str_int_2 CONV_s_i_ii
extern void str_int_2(string, int);


/* str_char(string,char) -- (i,o) */
#define str_char CONV_s_c_io
extern void str_char(string, char*);


/* str_char(string,char) -- (o,i) */
#define str_char_1 CONV_s_c_oi
extern void str_char_1(string*, char);


/* str_char(string,char) -- (i,i) */
#define str_char_2 CONV_s_c_ii
extern void str_char_2(string, char);


/* str_real(string,real) -- (i,o) */
#define str_real CONV_s_r_io
extern void str_real(string, double*);


/* str_real(string,real) -- (o,i) */
#define str_real_1 CONV_s_r_oi
extern void str_real_1(string*, double);


/* str_real(string,real) -- (i,i) */
#define str_real_2 CONV_s_r_ii
extern void str_real_2(string, double);


/* str_ref(string,ref) -- (i,o) */
#define str_ref CONV_Str_Ref_io
extern void str_ref(string, dbref*);


/* str_ref(string,ref) -- (o,i) */
#define str_ref_1 CONV_Str_Ref_oi
extern void str_ref_1(string*, dbref);


/* str_ref(string,ref) -- (i,i) */
#define str_ref_2 CONV_Str_Ref_ii
extern void str_ref_2(string, dbref);


/* real_ints(real,integer,integer,integer,integer) -- (i,o,o,o,o)*/
#define real_ints CONV_r_ints_io
extern void real_ints(double, int*, int*, int*, int*);


/* real_ints(real,integer,integer,integer,integer) -- (o,i,i,i,i)*/
#define real_ints_1 CONV_r_ints_oi
extern void real_ints_1(double*, int, int, int, int);


/* edit(string,string) -- (i,o) */
#define edit ED_Edit_2
extern void edit(string, string*);


/* edit(string,string,string,string,string,integer,string,integer) -- (i,o,i,i,i,i,i,o) */
#define edit_1 ED_EditMsg
extern void edit_1(string, string*, string, string, string, int, string, int*);


/* edit(string,string,string,string,string,integer,string,integer,integer,integer,integer,integer,integer) -- (i,o,i,i,i,i,i,i,i,i,i,o,o) */
#define edit_2 ED_EditMsg2
extern void edit_2(string, string*, string, string, string, int, string, int, int, int, int, int*, int*);


/* edit(string,string,string,string,string,integer,string,integer,integer,integer,integer,integer,integer,integer,integer,integer)
									 -- (i,o,i,i,i,i,i,i,i,i,i,o,o,i,i,i) */
#define edit_3 ED_EditMsg3
extern void edit_3(string, string*, string, string, string, int,string, int, int, int, int, int*, int*, int, int, int);


/* edit(string,string,string,string,string,integer,string,integer,integer,integer,integer,integer,integer,
	integer,integer,integer,integer,integer, string, string) */

#define edit_4 ED_EditMsg4
extern void edit_4(string, string*, string, string, string, int, string, int,
	int, int, int, int*, int*, int, int, int, int, int, string, string);


/* display(string) -- (i) */
#define display ED_Display
extern void display(string);


/* pastebuffer(string) -- (i) */
#define pastebuffer ED_PasteBuffer_i
extern void pastebuffer(string);


/* pastebuffer(string) -- (o) */
#define pastebuffer_1 ED_PasteBuffer_o
extern void pastebuffer_1(string*);


/* applicationkey(integer,string) -- (i,i) */
#define applicationkey ED_SetAppMenuText
extern void applicationkey(int, string);


/* wrap_str(string,integer,char,string) -- (i,i,i,o) */
#define wrap_str ED_WrapStr
extern void wrap_str(string, int, char, string*);


/* stlnstatus(string) -- (i) */
#define stlnstatus STLN_Status
extern void stlnstatus(string);


/* stlnstatus(string) -- (o) */
#define stlnstatus_1 STLN_Status_o
extern void stlnstatus_1(string*);


/* stlnsetup() -- () */
#define stlnsetup STLN_Config
extern void stlnsetup(void);


/* keyboardsetup() -- () */
#define keyboardsetup KEY_Config
extern void keyboardsetup(void);


/* configsave(string) -- (i) */
#define configsave CFG_Save
extern void configsave(string);


/* configload(string,string) -- (i,o) */
#define configload CFG_LoadPred
extern void configload(string, string*);


/* syspath(string,string) -- (o,o) */
#define syspath OS_SysPath
extern void syspath(string*, string*);


/* comline(string) -- (o) */
#define comline OS_ComLine
extern void comline(string*);


/* envsymbol(string,string) -- (i,o) */
#define envsymbol OS_EnvSymb
extern void envsymbol(string, string*);


/* storage() -- () */
#define storage RUN_PrintStorage
extern void storage(void);


/* storage(real,real,real) -- (o,o,o) */
#define storage_1 RUN_Storage
extern void storage_1(double*, double*, double*);


/* date(integer,integer,integer) -- (o,o,o) */
#define date OS_Date_ooo
extern void date(int*, int*, int*);


/* date(integer,integer,integer) -- (i,i,i) */
#define date_1 OS_Date_iii
extern void date_1(int, int, int);


/* date(integer,integer,integer,integer) -- (o,o,o,o) */
#define date_2 OS_Date_oooo
extern void date_2(int*, int*, int*, int*);


/* time(integer,integer,integer,integer) -- (o,o,o,o) */
#define time OS_Time_oooo
extern void time(int*, int*, int*, int*);


/* time(integer,integer,integer,integer) -- (i,i,i,i) */
#define time_1 OS_Time_iiii
extern void time_1(int, int, int, int);


/* system(string) -- (i) */
#define system OS_System1
extern void system(string);


/* system(string,integer,integer) -- (i,i,o) */
#define system_1 OS_System3
extern void system_1(string, int, int*);


/* dir(string,string,string) -- (i,i,o) */
#define dir DIR_Browser3
extern void dir(string, string, string*);


/* dir(string,string,string,integer,integer,integer) --(i,i,o,i,i,i) */
#define dir_1 DIR_Browser6
extern void dir_1(string, string, string*, int, int, int);


/* diropen(string,integer,string) -- (i,i,o) */
#define diropen DIR_FindOpen
extern void diropen(string, int, string*);


/* dirmatch(string,string,integer,integer,integer,integer,integer,integer,integer,real) -- (i,o,o,o,o,o,o,o,o,o) */
#define dirmatch DIR_FindMatch
extern void dirmatch(string, string*, int*, int*, int*, int*, int*, int*, int*, double*);


/* dirclose(string) -- (i) */
#define dirclose DIR_FindClose
extern void dirclose(string);


/* dirfiles(string,integer,string,integer,integer,integer,integer,integer,integer,integer,real)-- (i,i,o,o,o,o,o,o,o,o,o) */
#define dirfiles DIR_FindFiles
extern void dirfiles(string, int, string*, int*, int*, int*, int*, int*, int*, int*, double*);


/* fileattrib(string,integer) -- (i,i) */
#define fileattrib DIR_SetFAttr
extern void fileattrib(string, int);


/* fileattrib(string,integer) -- (i,o) */
#define fileattrib_1 DIR_GetFAttr
extern void fileattrib_1(string, int*);


/* sleep(integer) -- (i) */
#define sleep OS_Sleep
extern void sleep(int);


/* marktime(integer,real) -- (i,o) */
#define marktime OS_MarkTime
extern void marktime(int, double*);


/* timeout(real) -- (i) */
#define timeout OS_TimeOut
extern void timeout(double);


/* osversion(string) -- (o) */
#define osversion OS_Version
extern void osversion(string*);


/* diskspace(integer,real) -- (i,o) */
#define diskspace IO_DiskSpace
extern void diskspace(int, double*);


/* errormsg(string,integer,string,string) -- (i,i,o,o) */
#define errormsg ERR_ErrorMsg
extern void errormsg(string, int, string*, string*);


/* lasterror(integer,string,string,integer) -- (o,o,o,o) */
#define lasterror ERR_LastError
extern void lasterror(int*, string*, string*, int*);


/* readtermerror(string,integer) -- (o,o) */
#define readtermerror RNT_ReadTermErr
extern void readtermerror(string*, int*);


/* consulterror(string,integer,real) -- (o,o,o) */
#define consulterror RNT_ConsultErr
extern void consulterror(string*, int*, double*);


/* random(real) -- (o) */
#define random PFP_Random
extern void random(double*);


/* random(integer,integer) -- (i,o) */
#define random_1 INTG_Random
extern void random_1(int, int*);


/* randominit(integer) -- (i) */
#define randominit LONG_RandomReInit
extern void randominit(int);


/* debug() -- () */
#define debug RUN_Debug
extern void debug(void);


/* trace(string) -- (i) */
#define trace RNT_Trace_i
extern void trace(string);


/* trace(string) -- (o) */
#define trace_1 RNT_Trace_o
extern void trace_1(string*);


/* true() -- () */
#define true RUN_True
extern void true(void);


/* break(string) -- (i) */
#define break BRK_Break_i
extern void break(string);


/* break(string) -- (o) */
#define break_1 BRK_Break_o
extern void break_1(string*);


/* breakpressed() -- () */
#define breakpressed BRK_CheckPressed
extern void breakpressed(void);


/* sound(integer,integer) -- (i,i) */
#define sound OS_Sound
extern void sound(int, int);


/* bios(integer,reg,reg) -- (i,i,reg(o,o,o,o,o,o,o,o)) */
#define bios OS_bios_iii
extern void bios(int, pro_regs, pro_regs);


/* bios(integer,reg,reg) -- (i,i,o) */
#define bios_1 OS_bios_iio
extern void bios_1(int, pro_regs, pro_regs*);


/* bios(integer,reg,reg,integer) -- (i,i,reg(o,o,o,o,o,o,o,o),o) */
#define bios_2 OS_bios_iiio
extern void bios_2(int, pro_regs, pro_regs, int*);


/* bios(integer,reg,reg,integer) -- (i,i,o,o) */
#define bios_3 OS_bios_iioo
extern void bios_3(int, pro_regs, pro_regs*, int*);


/* port_byte(integer,integer) -- (i,i) */
#define port_byte BIT_Port_Byte_ii
extern void port_byte(int, int);


/* port_byte(integer,integer) -- (i,o) */
#define port_byte_1 BIT_Port_Byte_io
extern void port_byte_1(int, int*);


/* ptr_dword(string,integer,integer) -- (i,o,o) */
#define ptr_dword BIT_Ptr_Dword_ioo
extern void ptr_dword(string, int*, int*);


/* ptr_dword(string,integer,integer) -- (o,i,i) */
#define ptr_dword_1 BIT_Ptr_Dword_oii
extern void ptr_dword_1(string*, int, int);


/* memword(integer,integer,integer) -- (i,i,o) */
#define memword BIT_Memword_iio
extern void memword(int, int, int*);


/* memword(integer,integer,integer) -- (i,i,i) */
#define memword_1 BIT_Memword_iii
extern void memword_1(int, int, int);


/* membyte(integer,integer,integer) -- (i,i,o) */
#define membyte BIT_Membyte_iio
extern void membyte(int, int, int*);


/* membyte(integer,integer,integer) -- (i,i,i) */
#define membyte_1 BIT_Membyte_iii
extern void membyte_1(int, int, int);


/* bitand(integer,integer,integer) -- (i,i,o) */
#define bitand BIT_Bitand
extern void bitand(int, int, int*);


/* bitor(integer,integer,integer) -- (i,i,o) */
#define bitor BIT_Bitor
extern void bitor(int, int, int*);


/* bitxor(integer,integer,integer) -- (i,i,o) */
#define bitxor BIT_Bitxor
extern void bitxor(int, int, int*);


/* bitnot(integer,integer) -- (i,o) */
#define bitnot BIT_Bitnot
extern void bitnot(int, int*);


/* bitleft(integer,integer,integer) -- (i,i,o) */
#define bitleft BIT_Bitleft
extern void bitleft(int, int, int*);


/* bitright(integer,integer,integer) -- (i,i,o) */
#define bitright BIT_Bitright
extern void bitright(int, int, int*);


/* availableems(real) -- (o) */
#define availableems EMM_Available
extern void availableems(double*);


/* db_create(db_selector,string,place) -- (i,i,i) */
#define db_create DB_Create
extern void db_create(db_selector, string, place);


/* db_open(db_selector,string,place) -- (i,i,i) */
#define db_open DB_Open
extern void db_open(db_selector, string, place);


/* db_open(db_selector,string,accessmode,denymode) -- (i,i,i,i) */
#define db_open_1 DB_OpenShare
extern void db_open_1(db_selector, string, access, deny);


/* db_openinvalid(db_selector,string,place) -- (i,i,i) */
#define db_openinvalid DB_OpenInvalid
extern void db_openinvalid(db_selector, string, place);


/* db_delete(string,place) -- (i,i) */
#define db_delete DB_Delete
extern void db_delete(string, place);


/* db_flush(db_selector) -- (i) */
#define db_flush DB_Flush
extern void db_flush(db_selector);


/* db_copy(db_selector,string,place) -- (i,i,i) */
#define db_copy DB_Copy
extern void db_copy(db_selector, string, place);


/* db_close(db_selector) -- (i) */
#define db_close DB_Close
extern void db_close(db_selector);


/* db_begintransaction(db_selector,accessmode) -- (i,i) */
#define db_begintransaction DB_BeginTransaction
extern void db_begintransaction(db_selector, access);


/* db_endtransaction(db_selector) -- (i) */
#define db_endtransaction DB_EndTransaction
extern void db_endtransaction(db_selector);


/* db_updated(db_selector) -- (i) */
#define db_updated DB_Updated
extern void db_updated(db_selector);


/* db_setretry(db_selector,integer,integer) -- (i,i,i) */
#define db_setretry DB_SetRetry
extern void db_setretry(db_selector, int, int);


/* db_statistics(db_selector,real,real,real,real) -- (i,o,o,o,o) */
#define db_statistics DB_Statistics
extern void db_statistics(db_selector, double*, double*, double*, double*);


/* db_garbagecollect(db_selector) -- (i) */
#define db_garbagecollect DB_GarbageCollect
extern void db_garbagecollect(db_selector);


/* db_reuserefs(db_selector,integer) -- (i,i) */
#define db_reuserefs DB_ReUseRef
extern void db_reuserefs(db_selector, int);


/* term_delete(db_selector,string,ref) -- (i,i,i) */
#define term_delete DB_TermDelete
extern void term_delete(db_selector, string, dbref);


/* chain_delete(db_selector,string) -- (i,i) */
#define chain_delete DB_ChainDelete
extern void chain_delete(db_selector, string);


/* chain_first(db_selector,string,ref) -- (i,i,o) */
#define chain_first DB_ChainFirst
extern void chain_first(db_selector, string, dbref*);


/* chain_last(db_selector,string,ref) -- (i,i,o) */
#define chain_last DB_ChainLast
extern void chain_last(db_selector, string, dbref*);


/* chain_next(db_selector,ref,ref) -- (i,i,o) */
#define chain_next DB_ChainNext
extern void chain_next(db_selector, dbref, dbref*);


/* chain_prev(db_selector,ref,ref) -- (i,i,o) */
#define chain_prev DB_ChainPrev
extern void chain_prev(db_selector, dbref, dbref*);


/* ref_bin(db_selector,ref,string,integer) -- (i,i,o,o) */
#define ref_bin DB_RefBin
extern void ref_bin(db_selector, dbref, string*, int*);


/* chain_bininserta(db_selector,string,string,integer,ref) -- (i,i,i,i,o) */
#define chain_bininserta DB_Inserta
extern void chain_bininserta(db_selector, string, string, int, dbref*);


/* chain_bininsertz(db_selector,string,string,integer,ref) -- (i,i,i,i,o) */
#define chain_bininsertz DB_Insertz
extern void chain_bininsertz(db_selector, string, string, int, dbref*);


/*chain_bininsertafter(db_selector,string,ref,string,integer,ref) -- (i,i,i,i,i,o) */
#define chain_bininsertafter DB_InsertAfter
extern void chain_bininsertafter(db_selector, string, dbref, string, int, dbref*);


/* bin_replace(db_selector,ref,string,integer) -- (i,i,i,i) */
#define bin_replace DB_DbaseReplace
extern void bin_replace(db_selector, dbref, string, int);


/* key_next(db_selector,integer,ref) -- (i,i,o) */
#define key_next DB_KeyNext
extern void key_next(db_selector, int, dbref*);


/* key_prev(db_selector,integer,ref) -- (i,i,o) */
#define key_prev DB_KeyPrev
extern void key_prev(db_selector, int, dbref*);


/* key_first(db_selector,integer,ref) -- (i,i,o) */
#define key_first DB_KeyFirst
extern void key_first(db_selector, int, dbref*);


/* key_last(db_selector,integer,ref) -- (i,i,o) */
#define key_last DB_KeyLast
extern void key_last(db_selector, int, dbref*);


/* key_search(db_selector,integer,string,ref) -- (i,i,i,o) */
#define key_search DB_KeySearch_o
extern void key_search(db_selector, int, string, dbref*);


/* key_search(db_selector,integer,string,ref) -- (i,i,i,i) */
#define key_search_1 DB_KeySearch_i
extern void key_search_1(db_selector, int, string, dbref);


/* key_current(db_selector,integer,string,ref) -- (i,i,o,o) */
#define key_current DB_KeyCurrent
extern void key_current(db_selector, int, string*, dbref*);


/* key_insert(db_selector,integer,string,ref) -- (i,i,i,i) */
#define key_insert DB_KeyInsert
extern void key_insert(db_selector, int, string, dbref);


/* key_delete(db_selector,integer,string,ref) -- (i,i,i,i) */
#define key_delete DB_KeyDelete
extern void key_delete(db_selector, int, string, dbref);


/* bt_create(db_selector,string,integer,integer,integer) -- (i,i,o,i,i) */
#define bt_create DB_BtCreate5
extern void bt_create(db_selector, string, int*, int, int);


/* bt_create(db_selector,string,integer,integer,integer,integer) -- (i,i,o,i,i,i) */
#define bt_create_1 DB_BtCreate6
extern void bt_create_1(db_selector, string, int*, int, int, int);


/* bt_open(db_selector,string,integer) -- (i,i,o) */
#define bt_open DB_BtOpen
extern void bt_open(db_selector, string, int*);


/* bt_close(db_selector,integer) -- (i,i) */
#define bt_close DB_BtClose
extern void bt_close(db_selector, int);


/* bt_delete(db_selector,string) -- (i,i) */
#define bt_delete DB_BtDelete
extern void bt_delete(db_selector, string);


/* bt_updated(db_selector,integer) -- (i,i) */
#define bt_updated DB_BtUpdated
extern void bt_updated(db_selector, int);


/* bt_statistics(db_selector,integer,real,real,integer,integer,integer,integer) -- (i,i,o,o,o,o,o,o) */
#define bt_statistics DB_BtStatistics
extern void bt_statistics(db_selector, int, double*, double*, int*, int*, int*, int*);


/* bt_copyselector(db_selector,integer,integer) -- (i,i,o) */
#define bt_copyselector DB_BtCopySelector
extern void bt_copyselector(db_selector, int, int*);


/* detectgraph(integer,integer) -- (o,o) */
#define detectgraph BGI_detectgraph
extern void detectgraph(int*, int*);


/* initgraph(integer,integer,integer,integer,string) -- (i,i,o,o,i) */
#define initgraph BGI_initgraph
extern void initgraph(int, int, int*, int*, string);


/* closegraph() -- () */
#define closegraph BGI_closegraph
extern void closegraph(void);


/* graphdefaults() -- () */
#define graphdefaults BGI_graphdefaults
extern void graphdefaults(void);


/* restorecrtmode() -- () */
#define restorecrtmode BGI_restorecrtmode
extern void restorecrtmode(void);


/* getgraphmode(integer) -- (o) */
#define getgraphmode BGI_getgraphmode
extern void getgraphmode(int*);


/* setgraphmode(integer) -- (i) */
#define setgraphmode BGI_setgraphmode
extern void setgraphmode(int);


/* setgraphbufsize(integer) -- (i) */
#define setgraphbufsize BGI_setgraphbufsize
extern void setgraphbufsize(int);


/* arc(integer,integer,integer,integer,integer) -- (i,i,i,i,i) */
#define arc BGI_arc
extern void arc(int, int, int, int, int);


/* circle(integer,integer,integer) -- (i,i,i) */
#define circle BGI_circle
extern void circle(int, int, int);


/* drawpoly(bgi_ilist) -- (i) */
#define drawpoly BGI_drawpoly
extern void drawpoly(bgi_ilist);


/* ellipse(integer,integer,integer,integer,integer,integer) -- (i,i,i,i,i,i) */
#define ellipse BGI_ellipse
extern void ellipse(int, int, int, int, int, int);


/* getarccoords(integer,integer,integer,integer,integer,integer) -- (o,o,o,o,o,o) */
#define getarccoords BGI_getarccoords
extern void getarccoords(int*, int*, int*, int*, int*, int*);


/* getaspectratio(integer,integer) -- (o,o) */
#define getaspectratio BGI_getaspectratio
extern void getaspectratio(int*, int*);


/* getlinesettings(integer,integer,integer) -- (o,o,o) */
#define getlinesettings BGI_getlinesettings
extern void getlinesettings(int*, int*, int*);


/* line(integer,integer,integer,integer) -- (i,i,i,i) */
#define line BGI_line
extern void line(int, int, int, int);


/* linerel(integer,integer) -- (i,i) */
#define linerel BGI_linerel
extern void linerel(int, int);


/* lineto(integer,integer) -- (i,i) */
#define lineto BGI_lineto
extern void lineto(int, int);


/* moveto(integer,integer) -- (i,i) */
#define moveto BGI_moveto
extern void moveto(int, int);


/* moverel(integer,integer) -- (i,i) */
#define moverel BGI_moverel
extern void moverel(int, int);


/* rectangle(integer,integer,integer,integer) -- (i,i,i,i) */
#define rectangle BGI_rectangle
extern void rectangle(int, int, int, int);


/* setlinestyle(integer,integer,integer) -- (i,i,i) */
#define setlinestyle BGI_setlinestyle
extern void setlinestyle(int, int, int);


/* bar(integer,integer,integer,integer) -- (i,i,i,i) */
#define bar BGI_bar
extern void bar(int, int, int, int);


/* bar3d(integer,integer,integer,integer,integer,integer) -- (i,i,i,i,i,i) */
#define bar3d BGI_bar3d
extern void bar3d(int, int, int, int, int, int);


/* fillpoly(bgi_ilist) -- (i) */
#define fillpoly BGI_fillpoly
extern void fillpoly(bgi_ilist);


/* floodfill(integer,integer,integer) -- (i,i,i) */
#define floodfill BGI_floodfill
extern void floodfill(int, int, int);


/* getfillpattern(bgi_ilist) -- (o) */
#define getfillpattern BGI_getfillpattern
extern void getfillpattern(bgi_ilist*);


/* getfillsettings(integer,integer) -- (o,o) */
#define getfillsettings BGI_getfillsettings
extern void getfillsettings(int*, int*);


/* pieslice(integer,integer,integer,integer,integer) -- (i,i,i,i,i) */
#define pieslice BGI_pieslice
extern void pieslice(int, int, int, int, int);


/* pieslicexy(integer,integer,integer,integer,integer,integer) -- (i,i,i,i,i,i) */
#define pieslicexy BGI_piesliceXY
extern void pieslicexy(int, int, int, int, int, int);


/* setfillpattern(bgi_ilist,integer) -- (i,i) */
#define setfillpattern BGI_setfillpattern
extern void setfillpattern(bgi_ilist, int);


/* setfillstyle(integer,integer) -- (i,i) */
#define setfillstyle BGI_setfillstyle
extern void setfillstyle(int, int);


/* cleardevice() -- () */
#define cleardevice BGI_cleardevice
extern void cleardevice(void);


/* setactivepage(integer) -- (i) */
#define setactivepage BGI_setactivepage
extern void setactivepage(int);


/* setvisualpage(integer) -- (i) */
#define setvisualpage BGI_setvisualpage
extern void setvisualpage(int);


/* clearviewport() -- () */
#define clearviewport BGI_clearviewport
extern void clearviewport(void);


/* getviewsettings(integer,integer,integer,integer,integer) -- (o,o,o,o,o) */
#define getviewsettings BGI_getviewsettings
extern void getviewsettings(int*, int*, int*, int*, int*);


/* setviewport(integer,integer,integer,integer,integer) -- (i,i,i,i,i) */
#define setviewport BGI_setviewport
extern void setviewport(int, int, int, int, int);


/* getimage(integer,integer,integer,integer,string) -- (i,i,i,i,o) */
#define getimage BGI_getimage
extern void getimage(int, int, int, int, string*);


/* imagesize(integer,integer,integer,integer,integer) -- (i,i,i,i,o) */
#define imagesize BGI_imagesize
extern void imagesize(int, int, int, int, int*);


/* putimage(integer,integer,string,integer) -- (i,i,i,i) */
#define putimage BGI_putimage
extern void putimage(int, int, string, int);


/* getpixel(integer,integer,integer) -- (i,i,o) */
#define getpixel BGI_getpixel
extern void getpixel(int, int, int*);


/* putpixel(integer,integer,integer) -- (i,i,i) */
#define putpixel BGI_putpixel
extern void putpixel(int, int, int);


/* gettextsettings(integer,integer,integer,integer,integer) -- (o,o,o,o,o) */
#define gettextsettings BGI_gettextsettings
extern void gettextsettings(int*, int*, int*, int*, int*);


/* outtext(string) -- (i) */
#define outtext BGI_outtext
extern void outtext(string);


/* outtextxy(integer,integer,string) -- (i,i,i) */
#define outtextxy BGI_outtextcoord
extern void outtextxy(int, int, string);


/* settextjustify(integer,integer) -- (i,i) */
#define settextjustify BGI_settextjustify
extern void settextjustify(int, int);


/* settextstyle(integer,integer,integer) -- (i,i,i) */
#define settextstyle BGI_settextstyle
extern void settextstyle(int, int, int);


/* setusercharsize(integer,integer,integer,integer) -- (i,i,i,i) */
#define setusercharsize BGI_setusercharsize
extern void setusercharsize(int, int, int, int);


/* textheight(string,integer) -- (i,o) */
#define textheight BGI_textheight
extern void textheight(string, int*);


/* textwidth(string,integer) -- (i,o) */
#define textwidth BGI_textwidth
extern void textwidth(string, int*);


/* getmaxx(integer) -- (o) */
#define getmaxx BGI_getmaxx
extern void getmaxx(int*);


/* getmaxy(integer) -- (o) */
#define getmaxy BGI_getmaxy
extern void getmaxy(int*);


/* getx(integer) -- (o) */
#define getx BGI_getx
extern void getx(int*);


/* gety(integer) -- (o) */
#define gety BGI_gety
extern void gety(int*);


/* getbkcolor(integer) -- (o) */
#define getbkcolor BGI_getbkcolor
extern void getbkcolor(int*);


/* getcolor(integer) -- (o) */
#define getcolor BGI_getcolor
extern void getcolor(int*);


/* getmaxcolor(integer) -- (o) */
#define getmaxcolor BGI_getmaxcolor
extern void getmaxcolor(int*);


/* getpalette(bgi_ilist) -- (o) */
#define getpalette BGI_getpalette
extern void getpalette(bgi_ilist*);


/* setallpalette(bgi_ilist) -- (i) */
#define setallpalette BGI_setallpalette
extern void setallpalette(bgi_ilist);


/* setpalette(integer,integer) -- (i,i) */
#define setpalette BGI_setpalette
extern void setpalette(int, int);


/* setbkcolor(integer) -- (i) */
#define setbkcolor BGI_setbkcolor
extern void setbkcolor(int);


/* setcolor(integer) -- (i) */
#define setcolor BGI_setcolor
extern void setcolor(int);


/* setrgbcolor(integer,integer,integer,integer) -- (i,i,i,i) */
#define setrgbcolor BGI_setrgbcolor
extern void setrgbcolor(int, int, int, int);


/* getmoderange(integer,integer,integer) -- (i,o,o) */
#define getmoderange BGI_getmoderange
extern void getmoderange(int, int*, int*);


/* getpalettesize(integer) -- (o) */
#define getpalettesize BGI_getpalettesize
extern void getpalettesize(int*);


/* getmaxmode(integer) -- (o) */
#define getmaxmode BGI_getmaxmode
extern void getmaxmode(int*);


/* getmodename(integer,string) -- (i,o) */
#define getmodename BGI_getmodename
extern void getmodename(int, string*);


/* getdrivername(string) -- (o) */
#define getdrivername BGI_getdrivername
extern void getdrivername(string*);


/* getdefaultpalette(bgi_ilist) -- (o) */
#define getdefaultpalette BGI_getdefaultpalette
extern void getdefaultpalette(bgi_ilist*);


/* setaspectratio(integer,integer) -- (i,i) */
#define setaspectratio BGI_setaspectratio
extern void setaspectratio(int, int);


/* setwritemode(integer) -- (i) */
#define setwritemode BGI_setwritemode
extern void setwritemode(int);


/* fillellipse(integer,integer,integer,integer) -- (i,i,i,i) */
#define fillellipse BGI_fillellipse
extern void fillellipse(int, int, int, int);


/* installuserfont(string) -- (i) */
#define installuserfont BGI_installuserfont
extern void installuserfont(string);
