/*************************************************************************
	MAIN.PRO

	Main module for overlay demo

	Copyright (c) 1986, 1990 by Prolog Development Center             
**************************************************************************/

project "overlay"

include "globals.pro"

PREDICATES
  process(INTEGER)
  save_Screen restore_screen
CLAUSES
  process(1):-hanoi.
  process(2):-fwgc.
  process(3):-labyrinth.
  process(4):-save_screen,geobase, restore_screen.
  process(5):-register.
  process(6):-save_Screen,grdemo,restore_Screen. 
  
  
  process(7):-
	makewindow(1,7,7,"Memory status",5,5,15,70),
	storage(S,H,T),
	write("\nFree stack size=",S),
	write("\nFree heap size= ",H),
	write("\nFree trail size=",T),
	write("\n\nPress any KEY"),readchar(_),
	removewindow.
  process(8).
  
  save_screen:- 
  	textmode(H,W),
  	makewindow(45, 7,0, "", 0,0,H,W).
  restore_screen :-
  	shiftwindow(45), removewindow(45,1).	
	


GOAL	textmode(RR,CC),
	makewindow(18,7,0,"",0,0,RR,CC),
	makewindow(3,7,23,"",3,23,3,23),
	window_str("  OVERLAY DEMO"),
	menu_repeat(12,23,7,23,
	    [" Towers of Hanoi ",
	     " Farmer Wolf Goat Cabbage",
	     " Random Labyrinth Generator",
  	     " Geobase natural language interface ",
	     " Register Demo",
	     " Graphics demo",
	     " Show memory",
	     " End of demo"],
	     " Make a selection",1,Ch),
	process(Ch),
	Ch=8,!,
	removewindow(81,1),
	removewindow(3,1),
	removewindow(18,1).
	

