/*****************************************************************
	SCANDOM.C 

	Token definitions for C-based Scanner used with PRO2C

	Copyright (c) 1986, 1990 by Prolog Development Center
*****************************************************************/

#define VARFNO			0
#define CONSTFNO		1
#define LISTFNO		1
#define NILLFNO		2

#define INTEGER	int
#define CHAR		char
#define REAL		double
#define STRING		char*
#define SYMBOL		char*

typedef INTEGER	CURSOR;

typedef
  struct tokl_struct {
	unsigned char fno;
	struct cursortok_struct *cursortok;
	struct tokl_struct *next;
  } TOKL;

#define cursortok_t		1

typedef
  struct cursortok_struct {
	unsigned char fno;
	struct tok_struct *tok;
	CURSOR cursor;
  } CURSORTOK;

#define tok_or_			1
#define tok_comma			2
#define tok_global_		3
#define tok_domains_		4
#define tok_predicates_	5
#define tok_database_	6
#define tok_minus			7
#define tok_id				8
#define tok_equal			9
#define tok_reference_	10
#define tok_asterisk		11
#define tok_plus			12
#define tok_lpar			13
#define tok_rpar			14
#define tok_determ_		15
#define tok_nondeterm_	16
#define tok_language_	17
#define tok_as_			18
#define tok_str			19
#define tok_period		20
#define tok_nill			21

typedef
  struct tok_struct {
	unsigned char fno;
	union {
		STRING id;
		STRING str;
	} u;
  } TOK;


#define MAXTOKS 21

struct {
	STRING strtok;
	int fno;
} tokens[MAXTOKS] = {
	{";",tok_or_},
	{",",tok_comma},
	{"global",tok_global_},
	{"domains",tok_domains_},
	{"predicates",tok_predicates_},
	{"database",tok_database_},
	{"-",tok_minus},
	{"",tok_id},
	{"=",tok_equal},
	{"reference",tok_reference_},
	{"*",tok_asterisk},
	{"+",tok_plus},
	{"(",tok_lpar},
	{")",tok_rpar},
	{"determ",tok_determ_},
	{"nondeterm",tok_nondeterm_},
	{"language",tok_language_},
	{"as",tok_as_},
	{"",tok_str},
	{".",tok_period},
	{"",tok_nill}
};


void far cdecl scanner_0(STRING string,TOKL **tokl);

void far pascal str_tok_0(STRING string,TOK **tok);

void far pascal str_tok_1(STRING *string,TOK **tok);
