/***********************************************************************
	MYMENU.PRO

	Menu functions for pexpert system

	Copyright (c) 1986, 90 by Prolog Development Center
***********************************************************************/


PREDICATES
  menu(INTEGER,INTEGER,STRINGLIST,INTEGER)
  menu(INTEGER,INTEGER,SYMBOLLIST,INTEGER)
  readkey(KEY)
  /* Read key */
  readkey1(KEY,CHAR,INTEGER)
  readkey2(KEY,INTEGER)

  /* Menu selection */
  maxlen(STRINGLIST,INTEGER,INTEGER)
  maxlen(SYMBOLLIST,INTEGER,INTEGER)
  listlen(STRINGLIST,INTEGER)
  listlen(SYMBOLLIST,INTEGER)
  writelist(INTEGER,INTEGER,STRINGLIST)
  writelist(INTEGER,INTEGER,SYMBOLLIST)
  menu1(INTEGER,INTEGER,INTEGER,INTEGER)
  menu2(INTEGER,INTEGER,INTEGER,INTEGER,KEY)
  adjustvindow(INTEGER,INTEGER,INTEGER,INTEGER,INTEGER,INTEGER)


CLAUSES
  /**************************************************************/
  /* 			readkey					*/
  /**************************************************************/

  readkey(KEY):-readchar(T),char_int(T,VAL),readkey1(KEY,T,VAL).

  readkey1(KEY,_,0):-!,readchar(T),char_int(T,VAL),readkey2(KEY,VAL).
  readkey1(cr,_,13):-!.
  readkey1(esc,_,27):-!.
  readkey1(break,_,3):-!.
  readkey1(tab,_,0):-!.
  readkey1(bdel,_,8):-!.
  readkey1(tegn(T),T,_) .
  
  readkey2(btab,15):-!.
  readkey2(del,83):-!.
  readkey2(ins,82):-!.
  readkey2(up,72):-!.
  readkey2(down,80):-!.
  readkey2(left,75):-!.
  readkey2(right,77):-!.
  readkey2(home,71):-!.
  readkey2(end,79):-!.
  readkey2(ftast(N),VAL):- VAL>58 and VAL<70 and N=VAL-58, !.
  readkey2(otherspec,_).


  /**************************************************************/
  /* 			menu					*/
  /**************************************************************/

  menu(LI,KOL,LIST,CHOICE) :-
		maxlen(LIST,0,ANTKOL),
		listlen(LIST,ANTLI),ANTLI>0,!,
		HH1=ANTLI+2, HH2=ANTKOL+2,
		adjustvindow(LI,KOL,HH1,HH2,ALI,AKOL),
		makewindow(3,7,7,"",ALI,AKOL,HH1,HH2),
		HH3=ANTKOL,
		writelist(0,HH3,LIST),cursor(0,0),
		menu1(0,ANTLI,ANTKOL,CH),
		CHOICE=1+CH,
		removewindow.

  menu(_,_,_,255).
  
  maxlen([H|T],MAX,MAX1) :-
		str_len(H,LNGDE),
		LNGDE>MAX,!,
		maxlen(T,LNGDE,MAX1).
  maxlen([_|T],MAX,MAX1) :-maxlen(T,MAX,MAX1).
  maxlen([],LEN,LEN).

  listlen([],0).
  listlen([_|T],N):-
		listlen(T,X),
		N=X+1.

  writelist(_,_,[]).
  writelist(LI,ANTKOL,[H|T]):-field_str(LI,0,ANTKOL,H),
		LI1=LI+1,writelist(LI1,ANTKOL,T).

  menu1(LI,MAXLI,ANTKOL,CHOICE):-
		field_attr(LI,0,ANTKOL,112),
		cursor(LI,0),
		readkey(KEY),
		menu2(LI,MAXLI,ANTKOL,CHOICE,KEY).

  menu2(_,_,_,-1,esc):-!.
  menu2(LI,_,_,LI,ftast(10)):-!.
  menu2(LI,_,_,LI,cr):-!.
  menu2(LI,MAXLI,ANTKOL,CHOICE,up):-
		LI>0,!,
		field_attr(LI,0,ANTKOL,7),
		LI1=LI-1,
		menu1(LI1,MAXLI,ANTKOL,CHOICE).

  menu2(LI,MAXLI,ANTKOL,CHOICE,down):-
		LI<MAXLI-1,!,
		field_attr(LI,0,ANTKOL,7),
		LI1=LI+1,
		menu1(LI1,MAXLI,ANTKOL,CHOICE).

  menu2(LI,MAXLI,ANTKOL,CHOICE,_):-
		menu1(LI,MAXLI,ANTKOL,CHOICE).

  adjustvindow(LI,KOL,DLI,DKOL,LI,KOL):-LI<25-DLI, KOL<80-DKOL,!.
  adjustvindow(LI,_,DLI,DKOL,LI,AKOL):-LI<25-DLI, !, AKOL=80-DKOL.
  adjustvindow(_,KOL,DLI,DKOL,ALI,KOL):-KOL<80-DKOL, !, ALI=25-DLI.
  adjustvindow(_,_,DLI,DKOL,ALI,AKOL):-ALI=25-DLI, AKOL=80-DKOL.

