/***************************************************************************
	SCANDOMS.C
	
	Token definitions for the C scanner
	PRO2c will automatically generate a file of this form when it
    translates a Prolog program containing a domain named "TOK"; 
	 this file originated from applying PRO2C to SCANDOMS.PRO

	You will also need to fill out by hand the string portions of the 
   token array to provide the actual textual representation of each 
   token, as has been done in the file below

	Copyright (c) 1986,1990 by Prolog Development Center
***************************************************************************/
#define VARFNO			0
#define CONSTFNO		1
#define LISTFNO		1
#define NILLFNO		2

#define INTEGER		int
#define CHAR		char
#define REAL		double
#define STRING		char*
#define SYMBOL		char*

typedef INTEGER	CURSOR;

typedef
  struct tokl_struct {
	unsigned char fno;
	struct cursortok_struct *cursortok;
	struct tokl_struct *next;
  } TOKL;

#define cursortok_t		1

typedef
  struct cursortok_struct {
	unsigned char fno;
	struct tok_struct *tok;
	CURSOR cursor;
  } CURSORTOK;

#define tok_comma		1
#define tok_plus		2
#define tok_minus		3
#define tok_mult		4
#define tok_div		5
#define tok_power		6
#define tok_exclmmark		7
#define tok_questionmark	8
#define tok_colon		9
#define tok_id			10
#define tok_lpar		11
#define tok_rpar		12
#define tok_int		13
#define tok_real		14
#define tok_str		15
#define tok_char		16
#define tok_if_		17
#define tok_then		18
#define tok_else		19
#define tok_while		20
#define tok_do			21
#define tok_goto		22
#define tok_nill		23

typedef
  struct tok_struct {
	unsigned char fno;
	union {
		STRING id;
		INTEGER int_0;
		REAL real;
		STRING str;
		CHAR char_0;
	} u;
  } TOK;


#define MAXTOKS 23

struct {
	STRING strtok;
	int fno;
} tokens[MAXTOKS] = {
	{",",tok_comma},
	{"+",tok_plus},
	{"-",tok_minus},
	{"*",tok_mult},
	{"/",tok_div},
	{"^",tok_power},
	{"!",tok_exclmmark},
	{"?",tok_questionmark},
	{":",tok_colon},
	{"",tok_id},
	{"(",tok_lpar},
	{")",tok_rpar},
	{"",tok_int},
	{"",tok_real},
	{"",tok_str},
	{"",tok_char},
	{"if",tok_if_},
	{"then",tok_then},
	{"else",tok_else},
	{"while",tok_while},
	{"do",tok_do},
	{"goto",tok_goto},
	{"",tok_nill}
};


void far cdecl scanner_0(STRING string,TOKL **tokl);
