/**************************************************************************
	COINS_ND.PRO

	Non-deterministic version of the coin changing problem

	Copyright (c) 1986,1990 by Prolog Development Center
**************************************************************************/

DOMAINS
change = item(integer,integer)
changelist = change*

PREDICATES
nondeterm coin(integer)
nondeterm make(integer,integer,changelist)

CLAUSES
coin(100).
coin(50).
coin(20).
coin(10).
coin(5).
coin(2).
coin(1).

make(0,0,[]):- !.
make(Amount,No_of_coins,[item(N,Value)|Coinlist]):-
        coin(Value), N = Amount div Value,
        N<>0, Remainder = Amount-(N*Value),
        make(Remainder,Rem_no_of_coins,Coinlist),
        No_of_coins = Rem_no_of_coins+N.

GOAL
	make(573,N,CL),
	write(N," coins:\nCL=",CL,"\n\n"),
	fail. % Force backtracking in an attempt to find more then one sol'n
