/**************************************************************************
	FINDMATE.PRO
	
	Example illustrating diagnostics info
	 try the goal  person("Ben Brown",Dom,Age,Sex,Interests)
  	  then the goal  person("Ben Brown",Dom,28,Sex,Interests)	
	and note the difference in both determinism & flowpattern

	Copyright 1986, 1990 Prolog Development Center
***************************************************************************/	
diagnostics 

DOMAINS
  name, address = string
  age   = integer
  sex   = m(); f()
  interest  = symbol
  interests = interest*

PREDICATES
  nondeterm person(name,address,age,sex,interests)
  list_all
  shared_interest(interests,interests)
  nondeterm member(interest,interests)

CLAUSES
person("Ben Brown", "Manhattan", 25, m(), [music,cars,homelife]).
person("Betty Ericson","Long Island", 21, f(), [food,children,homelife]).
person("Anne Berg", "Edinburgh", 28, f(), [opera,travelling]).
person("Phil Corrigan", "New York City", 33, m(), [travelling,music,cars]).
person("Ben Brown", "Washington", 24, m(), [music,cars,homelife]).
person("Victor Corn", "Washington", 29, m(), [cars,travelling,sport]).
person("Willy Garvin", "The Bahamas", 41, m(), [food,action,homelife]).
person("Robert Boyd", "London", 22, m(), [soul,travelling,sport]).
person("Marilyn McCane", "Hollywood", 46, f(), [food,movies,cars,homelife]).
person("Ben Brown", "Copenhagen", 28, m(), [music,cars,homelife]).

/****************************************************************
   A man and  woman are interested in each other if they
   share a common interest
****************************************************************/

  list_all:-
        person(MAN,_,_,m,IL1),
        person(WOMAN,_,_,f,IL2),
        shared_interest(IL1,IL2),
        write(MAN," is interested in ",WOMAN,'\n'),
        fail. /* Force backtracking to find all solutions */

  shared_interest(IL1,IL2):-
         member(X,IL1),
         member(X,IL2), !.

  member(X,[X|_]).
  member(X,[_|L]):- member(X,L).

GOAL 
  list_all
