/**************************************************************************
	MONEY.PRO

	Money puzzle:
	Defining clauses by backward & forward reasoning

	Copyright (c) 1986,1990 by Prolog Development Center
**************************************************************************/

DOMAINS
        list = reference integer*

PREDICATES
       nondeterm sum(list,list,list)
       nondeterm sum1(list,list,list,integer,integer,list,list)
       nondeterm digitsum(integer,integer,integer,integer,integer,list,list)
       nondeterm del(integer,list,list)

GOAL
        sum([0,S,E,N,D],[0,M,O,R,E],[M,O,N,E,Y]),M<>0,S<>0,
        write(" SEND\t ",S,E,N,D),nl,
        write(" MORE\t ",M,O,R,E),nl,
        write("-----\t ----"),nl,
        write("MONEY\t",M,O,N,E,Y),nl.

CLAUSES
sum(N1,N2,N):-
        sum1(N1,N2,N,
             0,0,
             [1,2,3,4,5,6,7,8,9,0],_).


sum1([],[],[],0,0,Digits,Digits):- !.
sum1([D1|Rest1],[D2|Rest2],[SumD|Sumlist],OldCarry,NewCarry,Digs1,Digs):-
        sum1(Rest1,Rest2,Sumlist,OldCarry,TempCarry,Digs1,Digs2),
        digitsum(D1,D2,TempCarry,SumD,NewCarry,Digs2,Digs).

digitsum(Dig1,Dig2,Carry,NewDig,NewCarry,OldDigslist,NewDigslist):-
        del(Dig1,OldDigslist,TempDigslist1),
        del(Dig2,TempDigslist1,TempDigslist2),
        del(NewDig,TempDigslist2,NewDigslist),    /* %%%% */
        S = Dig1+Dig2+Carry,
        NewDig = S mod 10,
        NewCarry = S div 10.


del(A,L,L):- bound(A), !.    /* so that initial carry of 0 is not
                                deleted from list of available digits
                                in clause %%%% above */
del(A,[A|L],L).
del(A,[B|L],[B|L1]):-del(A,L,L1).
