/**************************************************************************
	SORTQUIK.PRO
	
	More or less standard quicksort

	Copyright (c) 1986,1990 by Prolog Development Center
**************************************************************************/

        /************************************************/
        /*               QUICKSORT                      */
        /************************************************/

DOMAINS
  element=integer
  list=element*

PREDICATES
  quicksort(list,list)
  split(element,list,list,list)
  append(list,list,list)

CLAUSES
  quicksort([],[]).
  quicksort( [H | Tail],Sorted):-
        split(H,Tail,Before,After),
        quicksort(Before,BeforeSorted),
        quicksort(After,AfterSorted),
        append(BeforeSorted,[H|AfterSorted],Sorted).

  split(_,[],[],[]).
  split(H,[A|Tail],[A|Before],After):-
        A < H, !,
        split(H,Tail,Before,After).
  split(H,[A|Tail],Before,[A|After]):-
        split(H,Tail,Before,After).

  append([],L,L).
  append([X|L1],L2,[X|L3]):-
          append(L1,L2,L3).
