/**************************************************************************
	STRLIST1.PRO
	
	Combine list of strings into single string
	 see also the version under CPROGS directory

	Copyright (c) 1986,1990 by Prolog Development Center
**************************************************************************/

DOMAINS
slist = string*

PREDICATES
strlist_str(slist,string,string)
mr_nasty_strlist_str(slist,string)
bytes_needed(slist,integer,integer)
assign(slist,integer,integer)
assign_string(integer,integer,integer,integer,integer)

CLAUSES
strlist_str([H|T],P,S):-
        concat(P,H,S1),
        strlist_str(T,S1,S).
strlist_str([],S,S).

mr_nasty_strlist_str(L,S):-
        bytes_needed(L,0,B),
        str_len(S,B),
        ptr_dword(S,Seg,Offs),
        assign(L,Seg,Offs).

bytes_needed([H|T],N,S):-
        str_len(H,L1), N1=N+L1,
        bytes_needed(T,N1,S).
bytes_needed([],S,S).

assign([H|T],Seg,Offs):-
        ptr_dword(H,Seg1,Offs1),
        assign_string(Seg1,Offs1,Seg,Offs,N_Offs),
        assign(T,Seg,N_Offs).
assign([],_,_).

assign_string(Seg1,Offs1,Seg,Offs,Ret_Offs):-
        membyte(Seg1,Offs1,B), B<>0, !,
        membyte(Seg,Offs,B),
        N_Offs=Offs+1, N_Offs1=Offs1+1,
        assign_string(Seg1,N_Offs1,Seg,N_Offs,Ret_Offs).
assign_string(_,_,_,R,R).

GOAL
        storage(_,H1,_),
        strlist_str(
           ["The ","Mad ","Professor ","likes ","cutting ","tape,\n",
            "but ","when ","he ","misses ","Sandra ","gets ","Cross\n"
           ],"",S1),
        storage(_,H2,_),
        mr_nasty_strlist_str(
           ["The ","Mad ","Professor ","likes ","cutting ","tape,\n",
            "but ","when ","he ","misses ","Sandra ","gets ","Cross\n"
           ],S2),
        storage(_,H3,_),
        Heap1 = H1-H2, Heap2= H2-H3,
        write(S1,S2,"\nHeap usage:\nNice Method:   Nasty Method:\n"),
        writef(" % bytes        % bytes\n",Heap1,Heap2)
