/*
============================================================================
	MINITHEO.PRO 

	Small scale theorum prover

	Copyright (c) 1986, 1990 by Prolog Development Center
============================================================================
*/
DOMAINS
	propexp=not_(propexp);
		or_(propexp,propexp);
		and_(propexp,propexp);
		implies_(propexp,propexp);
		s_(symbol);
		a;b;c

DATABASE
	done(propexp,propexp,propexp)
	clause_(propexp)
PREDICATES
	translate(propexp)
	transform(propexp,propexp)	
	nondeterm delete(propexp,propexp,propexp)
	nondeterm in(propexp,propexp)
	replace(propexp,propexp)
	run
GOAL

	translate(or_(a,b)),run.       /* replace this with your own goal */
	
CLAUSES

	/* put propositional expression into normal form */

	translate(and_(F,G)):-
		!,translate(F), translate(G).

	translate(Formula):-
		transform(Formula,NewFormula),!,
		translate(NewFormula).

	translate(Formula):-
		assert(clause_(Formula)).

	transform(not_(not_(X)),X):-!.

	transform(implies_(X,Y),or_(not_(X),Y)):-!.

	transform(not_(and_(X,Y)),or_(not_(X),not_(Y))):-!.

	transform(not_(or_(X,Y)),and_(not_(X),not_(Y))):-!.

	transform(and_(X,or_(Y,Z)), and_(or_(X,Z),or_(Y,Z))):-!.

	transform(or_(X,and_(Y,Z)), and_(or_(X,Y),or_(X,Z))):-!.

	transform(or_(X,Y),or_(X1,Y)):-transform(X,X1),!.

	transform(or_(X,Y),or_(X,Y1)):-transform(Y,Y1).

	transform(not_(X),not_(X1)):-transform(X,X1).

/* given expression in normal form, resolve constituent clauses */

	run:-
	clause_(X),clause_(not_(X)),write(X,"contradiction found"),!.

	run:-
	clause_(C),in(P,C),in(not_(P),C),retract(clause_(C)),!.

	run:-
	clause_(C),delete(P,C,C1),in(P,C1),replace(C,C1),!.

	run:-
	clause_(P),clause_(C),delete(not_(P),C,C1),not(done(P,C,P)),
	assert(clause_(C1)),assert(done(P,C,P)),!.

	run:-
	clause_(not_(P)),clause_(C),delete(P,C,C1),not(done(not_(P),C,P)),
	assert(clause_(C1)),assert(done(not_(P),C,P)),!.

	run:-
	clause_(C1),delete(P,C1,CA),
	clause_(C2),delete(not_(P),C2,CB),not(done(C1,C2,P)),
	assert(clause_(or_(CA,CB))),assert(done(C1,C2,P)),!.

	run:- write("sorry, no contradiction found").


	delete(X,or_(X,Y),Y).
	delete(X,or_(Y,X),Y).
	delete(X,or_(Y,Z),or_(Y,Z1)):- delete(X,Z,Z1).

	delete(X,or_(Y,Z),or_(Y1,Z)):- delete(X,Y,Y1).

	in(X,X).
	in(X,Y):-delete(X,Y,_).

	replace(X,Y):-retract(clause_(X)),!,assert(clause_(Y)).
