/************************************************************************
	clock.pro

	Illustrates a timer event handler to display a clock on-screen
	
	NOTE: compile this example with STACK SIZE = 600 (the minimum)
	  eg,  prolog -c2 -S600 clock  
         for a smaller resident clock
	
	Copyright (C) 1990, Prolog Development Center
************************************************************************/
errorlevel = 0  % \
nobreak		%   no swap so it needs
trail= 1	%    to be small
heap = $100	%  /

include "RESIDENT.PRE"
PREDICATES
 write_tm(integer)

GOAL
    enableResident("clock", 0),
    installTimer(7, 100, needsDos_CantReenter), % every second
    stayResident.

CLAUSES
    timer(7) :-
	not(wasGraphics),
	textmode(_,Cols),
	Time_Col =  Cols - 9,
	time(H,M,S,_),
	cursor(0,Time_Col),
	write(H), 
	write_tm(M), 
	write_tm(S).

        write_tm(X) :-   
		X<10, !, write(":0",X) 
		; 
		write(":",X).
        
	
