/************************************************************************

   Global Stack cutting utility, for use with chelp.pro.
   
   Chelp.pro has a tail-recursive control structure that passes forward
   global-stack arguments, which thus prevents success-popping by the
   compiler, even though (human) analysis reveals that at least at certain 
   states in the program, the Gstack could in fact be cut back to its 
   initial state.   

   BE SURE you read and understand the sections on memory management
   and flow analysis before attempting such optimizations in your own
   programs!

*************************************************************************/
void * MEM_MarkGStack(void);
void MEM_ReleaseGStack(void * MARK);

void *gpointer;

void gstack_setup_0(void)
 {
 gpointer=MEM_MarkGStack();
 }

void cut_gstack_0(void)
 {
 MEM_ReleaseGStack(gpointer);
 }

