/************************************************************************
	ovl.pro

	Simple Example illustrating overlaid TSR

	ALT-F2 activates, ALT-F3 unloads

	Copyright (C) 1990, Prolog Development Center
************************************************************************/
heap = $1000

project "ovl"

include "RESIDENT.PRE"
include "KEYSCAN.PRE"

global predicates
 ovl1
 ovl2
 reOvl1

goal
    plinkCache(on),  
    %rtlinkCache(on),	% or use rtlinkcache
    enableResident("ovl", 0),
    enableSwap(swapToEms, "", "", Result),
    Result = 0,
    Flags = needsdos + cantreenter,    
    installHotkey(0, key_f2, eitherAlt, Flags),
    installHotKey(1, key_f3, eitherAlt, Flags),
    installSignal(0,Flags),	
    write("Alt-F2 to test; Alt-F3 to unload"),
    writedevice(stdout),cursorstate(on),
    stayResident;
    write("Unable to install... no EMS or already loaded?").

clauses
    hotkey(0) :- 
		ovl1,
		ovl2,
		reOvl1.

    Hotkey(1) :- removeResident("ovl").

    signal(0) :-
    	write("unloading OVL").
    	
