/************************************************************************
	poped.pro

	Example of a pop-up editor. Must be called with a filename to
	edit, eg.

	  poped poped.pro

	the file is held "in memory" between edits, but would be updated
        to disk if the program were removed with the "remove" utility

	Hotkey = Left Shift + F10

	Copyright (C) 1990, Prolog Development Center
************************************************************************/
heap = $2000
include "RESIDENT.PRE"
include "KEYSCAN.PRE"

CONSTANTS
 progname="poped"

DATABASE
 determ file_is(string)
 determ file_buffer_position(string, integer)

PREDICATES
 pick_textmode(integer,integer)	
 best_Swap

GOAL	comline(Filename),
	existfile(Filename),
	asserta(file_is(Filename)),
	file_str(Filename, Buf),
	asserta(file_buffer_position(Buf, 0)),
	enableResident(progname,0),
	best_Swap,
	installHotKey(1, key_F10, leftShift, needsDos_cantReenter),
	installSignal(kill_signal, needsDos_CantReenter),
	write("\n Hotkey is left shift + F10"),
	stayResident.
CLAUSES
 	hotKey(1) :-
		pick_textmode(Rows,Cols),
		saveVideo(Rows,Cols,_,_),
		makewindow(1, 7,7,"Pop-Edit", 0,0,Rows,Cols),
		retract(file_buffer_position(Buffer, Position)),
		setKeyboardSense(on),
		edit(Buffer,NewBuf,"","","",Position,"",1,1,1,1,NewPos,_),
		asserta(file_buffer_position(NewBuf, NewPos)),
		removewindow.	
		
	signal(kill_signal) :-
		file_buffer_position(Buf,_),
		file_is(Name),
		file_str(Name,Buf).

	pick_textmode(25,80) :- wasGraphics,!. 	    % was in a graphics mode
	pick_textmode(Rows,Cols) :- textmode(Rows,Cols).% use current mode

	best_Swap :- 
		enableSwap(swapToEms, "","", Status),
		Status=0,!,
		write(progname, " installed for EMS swap").
	best_Swap :- 
		enableSwap(swapToFile, "poped.swp","", Status),
		Status=0,!,
		write(progname, " installed for disk swap").
	best_Swap:- write(progname, " installed with no swapping").

		
