/************************************************************************
	reader.pro

	Illustrates how a TSR can receive data from some other 
	process.  Execute the program to it install as a TSR, then
        use the "writer" program to send it a message, eg.

	writer  <message>

	Copyright (C) 1990, Prolog Development Center
************************************************************************/
heap = $500

CONSTANTS
progname = "reader"

include "resident.pre"

PREDICATES
 	best_Swap

GOAL	enableResident(progname,256),
	best_swap,
	installSignal(data_received, needsDos_cantReenter),
	installSignal(kill_signal, needsDos_cantReenter),
	stayResident.

CLAUSES
 	signal(data_received) :-
		textmode(Rows,Cols),
		saveVideo(Rows,Cols,_,_),
		rdDataResident(progname, MSG),
		makewindow(1, 7,7," received ", 2,2,5,50),
		write(MSG),
		setKeyboardSense(on),
		readchar(_), 
		removewindow.
	
	signal(kill_signal) :- 
		cursorsync,
		write(progname, " is being terminated!").

	best_Swap :- 
		enableSwap(swapToEms, "","", Status),
		Status=0,!,
		write(progname, " installed for EMS swap").
	best_Swap :- 
		enableSwap(swapToFile, "reader.swp","", Status),
		Status=0,!,
		write(progname, " installed for disk swap").
	best_Swap:- write(progname, " installed with no swapping").

