/*
===========================================================================
	  BGIFIND.PRO
	   
	  Locate BGI drivers for run-time load

	  Copyright (C) 1990 Prolog Development Center	
===========================================================================
*/

PREDICATES
  bgi_find(string)
  bgi_env(string)
  no_bgi_err(integer)
  
CLAUSES
  bgi_find(BgiPath) :-		% initgraph looks in current dir anyway, 
  	syspath(PrologDir,_),	%  also look off of the prolog directory
  	bgi_env(EnvPath),	%  or this one, if set
  	format(BgiPaths,"%BGI;%",PrologDir,EnvPath),
 	searchfile(BgiPaths,"*.BGI", Found),
 	filenamepath(Found,BgiPath, _),!.
  bgi_find("").
	   	
  bgi_env(Path) :- envsymbol(bgi, Path),!.
  bgi_env("").  	

  
  no_bgi_err(1703) :-!,
  	makewindow(90,7,7,"Bgi Error", 10,10, 4, 45),
  	write("error: 1703"),nl,
  	write("must set bgi=<path> in DOS environment"),
  	readchar(_),
  	removewindow.
  no_bgi_err(E) :- exit(E). % pass to surrounding trap, if any