/*
=====================================================================
	MESSAGE.PRO
	
	Message Handling Predicates
	
	Copyright (C) 1990 Prolog Development Center
=====================================================================
*/


CLAUSES

	message(sbar(Selector),mousepressed(MouseX,MouseY,_)) :- !,
		sbar_mousepress(Selector,MouseX,MouseY).
	message(sbar(Selector),redraw) :- !,
		sbar_Redraw(Selector).
	message(sbar(Selector),set(_,Value,_)) :- !,
		sbar_set(Selector,Value).

	message(gwindow(Selector),mousepressed(X,Y,_)) :- !,
		gwindow_mousepress(Selector,X,Y).
	message(gwindow(Selector),redraw) :- !,
		gwindow_Redraw(Selector).

	message(dial(Selector),mousepressed(_,_,_)) :- !,
		dial_mousepress(Selector).
	message(dial(Selector),redraw) :- !,
		dial_Redraw(Selector).
	message(dial(Selector),set(_,Value,_)) :- !,
		dial_set(Selector,Value).

	message(drawlistView(Selector),mousepressed(MouseX,MouseY,_)) :- !,
		drawlistView_mousepress(Selector,MouseX,MouseY).

	message(drawlistView(Selector),redraw) :- !,
		drawlistView_Redraw(Selector).

	message(drawlistView(Selector),
			sbar_after_change(BarSelector,Value,Max)) :- !,
		drawlistView_sBarSet(Selector,BarSelector,Value,Max).

	message(drawlistView(Selector),set(BarSelector,Value,Max)) :- !,
		drawlistView_sBarSet(Selector,BarSelector,Value,Max).

	message(_,_) :- 
		sound(10,5000),
		outtextxy(0,0,"Unrecognized message"),
		readchar(_),
		fail.

