/*
==========================================================================
	READEXT.PRO

	Utility predicates for import routines

	Copyright (C) 1990 Prolog Development Center
==========================================================================
*/

PREDICATES
  read_char(Char)
  read_int(Integer)
  read_real(Real)
  read_long(Real)
  read_str(String)
  read_str2(String,String)
  read_strArr(Integer,String)
  read_strCtrlZ(String)
  read_str2CtrlZ(String,String)
  ignore(Integer)

CLAUSES
  read_char(X):-
	readchar(X).

  read_int(V) :-
	readchar(Low), 
	readchar(High), 
	bitleft(High,8,Vh), 
	V = Low + Vh.

  read_real(Real) :-
	read_int(V1), 
	read_int(V2), 
	read_int(V3), 
	read_int(V4),
	real_ints(Real,V1,V2,V3,V4).

  read_long(Long) :-
	read_int(VLow), 
	read_int(_), 	%throw away high order byte???
	Long=Vlow.

  read_str(Str) :- 
	read_str2("",Str).

  read_str2(Scur,Str) :-
	readchar(CH), 
	CH<>'\000', !,
	str_char(S1,CH), 
	concat(Scur,S1,Scur2),
	read_str2(Scur2,Str).
  read_str2(S,S).

  read_strArr(N,S) :-    
	readdevice(Device),
	filepos(Device,0,1),
  	readblock(N,S).


  read_strCtrlZ(Str) :- 
	read_str2CtrlZ("",Str).
  read_str2CtrlZ(Scur,Str) :-
	readchar(CH), 
	CH<>'\026', !, 	% CtrlZ => CP/M way signaling eof 
	str_char(S1,CH), 
	concat(Scur,S1,Scur2),
	read_str2CtrlZ(Scur2,Str).
  read_str2CtrlZ(S,S).


/*************************************************************
	Ignore Characters
*************************************************************/

  ignore(0) :- !.
  ignore(N) :- 
	readdevice(Device),
	filepos(Device, N, 1).


