/*
============================================================================
	COLORS.PRO
	
	Program to generate color constants include file COLORS.PRE

	Copyright 1990 (C) Prolog Development Center
============================================================================
*/


DOMAINS
  ATTR = INTEGER
  FILE = outputfile

PREDICATES
  nondeterm	background_color(STRING, ATTR)
  nondeterm	foreground_color(STRING, ATTR)
		main
		main_aux
		write_times(INTEGER, CHAR)	
CLAUSES
  background_color(black, 0).
  background_color(blue, 16).
  background_color(green, 32).
  background_color(cyan, 48).
  background_color(red, 64).
  background_color(magenta, 80).
  background_color(purple, 80).
  background_color(brown, 96).
  background_color(white, 112).

  foreground_color(black, 0).
  foreground_color(grey, 8).
  foreground_color(gray, 8).
  foreground_color(blue, 1).
  foreground_color(high_blue, 9).
  foreground_color(green, 2).
  foreground_color(high_green, 10).
  foreground_color(cyan, 3).
  foreground_color(high_cyan, 11).
  foreground_color(red, 4).
  foreground_color(high_red, 12).
  foreground_color(magenta, 5).
  foreground_color(purple, 5).
  foreground_color(high_magenta, 13).
  foreground_color(high_purple, 13).
  foreground_color(brown, 6).
  foreground_color(yellow, 14).
  foreground_color(white, 7).
  foreground_color(high_white, 15).
  
  main :-
	write("\nCreating colors.pre..."),
	openwrite(outputfile, "colors.pre"),
	writedevice(outputfile),
	write("/*\n"),
	write_times(75,'='),
	write("\n\tCOLORS.PRE\n\n\tColor Constant Definitions"),
	write("\n\n\tCopyright (C) 1990 Prolog Development Center\n"),
	write_times(75,'='),
	write("\n*/\n"),       
	write("CONSTANTS"),
	main_aux,
	closefile(outputfile),
	writedevice(screen),
	write("done.").
	
  main_aux :-
	foreground_color(FOREGROUND_COLOR, FOREGROUND_ATTRIBUTE),
	nl,
	background_color(BACKGROUND_COLOR, BACKGROUND_ATTRIBUTE),
	NORMAL_ATTRIBUTE = FOREGROUND_ATTRIBUTE + BACKGROUND_ATTRIBUTE,
	writef("\n  %_on_% = %d", FOREGROUND_COLOR, BACKGROUND_COLOR, NORMAL_ATTRIBUTE),
	fail.
  main_aux :-
	foreground_color(FOREGROUND_COLOR, FOREGROUND_ATTRIBUTE),
	nl,
	background_color(BACKGROUND_COLOR, BACKGROUND_ATTRIBUTE),
	FLASHING_ATTRIBUTE = FOREGROUND_ATTRIBUTE + BACKGROUND_ATTRIBUTE + 128,
	writef("\n  flashing_%_on_% = %d", FOREGROUND_COLOR, BACKGROUND_COLOR, FLASHING_ATTRIBUTE),
	fail.
  main_aux.

  write_times(0,_):-!.
  write_times(N, CHARACTER) :- 
	write(CHARACTER),
	N2= N - 1,
	write_times(N2, CHARACTER).

  	
GOAL
  main.
	
