/*
==============================================================================
	STATUS.PRO
	
	Status Line predicates
	 Uses window number 83
	
	Copyright (C) 1990 Prolog Development Center
==============================================================================	
*/

include "tdoms.pro"

ifndef globdecl
PREDICATES
  makestatus(ATTR,STRING)
  nondeterm tempstatus(ATTR,STRING)
  removestatus
  refreshstatus
  changestatus(STRING)
enddef

CLAUSES
  makestatus(ATTR,TXT):-
	shiftwindow(OLD),
	textmode(ROWS,COLS),
	ROWS1=ROWS-1,
	makewindow(83,ATTR,0,"",ROWS1,0,1,COLS),
	field_str(0,0,COLS,TXT),
	shiftwindow(OLD).

  tempstatus(ATTR,TXT):-
  	makestatus(ATTR,TXT).
  tempstatus(_,_):-
  	removestatus,
  	fail.

  removestatus:-
	shiftwindow(OLD),
	shiftwindow(83), 
	removewindow,
	shiftwindow(OLD).

  refreshstatus:-
	shiftwindow(OLD),
	shiftwindow(83),
	shiftwindow(OLD).

  changestatus(TXT):-
	shiftwindow(OLD),
	shiftwindow(83),
	textmode(_,COLS),
	field_str(0,0,COLS,TXT),
	shiftwindow(OLD).
