/*
==========================================================================
	XCALC.PRO
									
 	Calculator Demo of Parser Generator			
 	--------------------------------------------------------	 
  	Common domains/predicates/etc. and main goal (XCALC.PRO)	 
 								*	 
  	Abbreviations used in this file: 				 
 		cursortok	= token and cursor			 
  		par		= parser				 
 		pro		= prolog				 
  		sca		= scanner				 
  		tok		= token					 
   		tokl		= list of cursortoks			 
  		ui		= user interface			 

	Copyright (C) 1990 Prolog Development Center
==========================================================================  									 
*/

check_determ

CONSTANTS
  dialog_window	= 1

DOMAINS
  CURSOR	= INTEGER
  CURSORTOK 	= t(TOK, CURSOR)
  MESSAGE	= STRING
  RESULT	= REAL
  SOURCE	= STRING
  TOKL 		= CURSORTOK*

include "xcalc.dom"		% Parser domains (created by Parser Generator).

PREDICATES
  expect(CURSORTOK, TOKL, TOKL)
  syntax_error(MESSAGE, TOKL)

				% Contained Predicates
				% --------------------
include "windows.pro"		% window_...
include "xcalc.sca"		% scan/3
include "xcalc.par"		% s_expr/3
include "xcalc.run"		% calculate/2
include "xcalc.ui"		% user_interface/0

CLAUSES
  expect(TOK, [TOK|L],L).

  syntax_error(_, _).

GOAL
  window_Make(dialog_window, 
  	      white_on_blue, 
	      white_on_black,
  	      " Simple Calculator ", 
	      full),
  window_ChangeFrame(bottom, 
  		     center, 
  		     " Legal operators include *, /, +, -, ^, and parentheses. ",
  		     blue_on_white),
  user_interface,
  removewindow.  
  
