/*
===========================================================================
	XCALCULA.CS	
  									 
  	XCALCULA: Programming Language Demo of Parser Generator		 
  	-------------------------------------------------------		 
  	Operations involving Calcula source 
  									 
  	Top-level predicates: calcula_source_AllowUserToModify/0	 
  			      calcula_source_Load/0			 
  			      calcula_source_Retrieve/1			 
  			      calcula_source_Save/0			 
  									 
  	Abbreviations used in this file: esc 	 = escape		 
  					 headstr = header string	 
  									 
  									 
	Copyright (C) 1990 Prolog Development Center
===========================================================================
*/

CONSTANTS
  auto_indent		= 1
  clear_paste_buffer	= 1
  confirm_esc		= 1
  f10			= 0
  insert_mode		= 1
  no_headstr1		= "" 
  no_headstr2		= ""
  no_help_file		= ""
  no_textmode		= 0
  no_top_line_status	= 0
  read_and_write_mode	= 1

DATABASE - calcula_source
  determ	calcula_source(SOURCE)

PREDICATES
  nondeterm	calcula_source_AllowUserToModify
		calcula_source_Load
		calcula_source_Retrieve(SOURCE)
		calcula_source_Save
		get_message(MESSAGE, CURSOR)
  nondeterm	repeat_calcula_source_AllowUserToModify

CLAUSES
  calcula_source_AllowUserToModify :-
	calcula_source(CURRENT_SOURCE),
	window_Shift(calcula_source_window),
	window_ChangeFrame(bottom, left_justify, " F10 to execute ", blue_on_white),
	window_ChangeFrame(bottom, right_justify, " Esc to quit ", blue_on_white),
	get_message(MESSAGE, CURSOR),
  	edit(CURRENT_SOURCE, 
  	     NEW_SOURCE, 
  	     no_headstr1, 
  	     no_headstr2, 
  	     MESSAGE, 
  	     CURSOR, 
  	     no_help_file, 
  	     read_and_write_mode, 
  	     auto_indent, 
  	     insert_mode, 
  	     no_textmode,
  	     _,				% Don't care about return position.
  	     EXIT_CODE,
	     no_top_line_status,
	     confirm_esc,
	     clear_paste_buffer),
	EXIT_CODE = f10,	  	% Esc causes this clause to fail.
  	retractall(calcula_source(_)),
  	assert(calcula_source(NEW_SOURCE)),
	repeat_calcula_source_AllowUserToModify.
  
  calcula_source_Load :-
  	existfile("xcalcula.db"),
	!,
  	consult("xcalcula.db", calcula_source).
  calcula_source_Load :- assert(calcula_source("")).

  calcula_source_Retrieve(SOURCE) :-
  	calcula_source(SOURCE).
  	
  calcula_source_Save :- 
	save("xcalcula.db", calcula_source).

  get_message(MESSAGE, CURSOR) :- error(MESSAGE, CURSOR), !.
  get_message("Enter/Edit source.", 0).

  repeat_calcula_source_AllowUserToModify.
  repeat_calcula_source_AllowUserToModify :- calcula_source_AllowUserToModify.
  
