/*
===========================================================================
	XCFMENU.PRO

	Demo of cfmenu (confidence factors menu)

	Copyright (C) 1990 Prolog Development Center  									 
===========================================================================
*/

check_determ

include "ui\\cfmenu.pro"

PREDICATES
  score(INTEGERLIST,INTEGERLIST,INTEGER,REAL)
  score(INTEGERLIST,INTEGERLIST,INTEGER)
  getscore(REAL)
  career(REAL,STRING)

CLAUSES
  getscore(SCORE):-
	certainmenu(12,15,10,66,23,
	  ["organize lots of people to go over and talk to him/her",
	  "go over and talk to him or her yourself",
	  "just smile at him or her sympathetically",
	  "take no notice"],
	  "If you were at a party and saw someone standing alone, would you:",
	  0,A1),
	score(A1,[-2,-1,1,2],60,S1),

	certainmenu(12,15,10,66,23,
	  ["parties",
	  "going out for a meal",
	  "sports",
	  "movies",
	  "reading a book",
	  "flower arranging"],
	  "Which of the following activities do you most enjoy?",
	  0,A2),
	score(A2,[-3,-2,-1,1,2,3],120,S2),

	certainmenu(12,15,10,66,23,
	  ["obstinate",
	  "determined",
	  "ambitious",
	  "considerate",
	  "thoughtful",
	  "couldn't care what turns up"],
	  "Which one of the following best describes you?",
	  0,A3),
	score(A3,[-3,-2,-1,1,2,3],120,S3),

	certainmenu(12,15,10,66,23,
	  ["wild",
	  "very extroverted",
	  "extrovert",
	  "happy",
	  "quiet and refined",
	  "quiet",
	  "very introverted",
	  "extremely shy"],
	  "Which one of the following best describes you?",
	  0,A4),
	score(A4,[-4,-3,-2,-1,1,2,3,4],200,S4),
	SCORE = (S1+S2+S3+S4)/4,
	writef("\n--------------\nScore=%8.2",SCORE).


  career(Total,advertising):-
  	Total<-0.5,!.
  career(Total,computing):-
  	Total>-0.5,Total<0.5,!.
  career(_,archeology).


  score(ANSLIST,WEIGTS,MAX,SCORE):-
	score(ANSLIST,WEIGTS,SCORE1),
	SCORE=SCORE1/MAX,
	writef("\nSubscore=%5.2",SCORE).

  score([],[],0).
  score([H|T],[H1|T1],SCORE):-
	score(T,T1,SCORE1),
	SCORE=SCORE1+H*H1.

GOAL	textmode(25,80),  
	textmode(ROWS,COLS),
	makewindow(1,7,0,"",0,0,ROWS,COLS),
	attribute(15),
	write("\t\t\tC A R E E R   A D V I S O R"),
	write("\n\t\t\t---------------------------"),
	attribute(14),
	write("\n\nYou will now be given four questions with a number of choices"),
	write("\nfor each answer. For each of the choices, use the arrow keys "),
	write("\nto indicate the degree to which the choice fits you"),
	attribute(10),
	write("\n\n     - Up and down to select choice"),
	write("\n     - Left and right to change truthness"),
	attribute(14),
	write("\n\nand press F10 when finished"),
	write("\n"),
	write("\n\n\n"),
	attribute(1),
	getscore(Total),
	career(Total,Job),
	makewindow(1,32,66,"Career",20,15,5,50),
	nl,write("        You should be in ",Job),
	readchar(_).
