/*
=====================================================================

	XCHART.PRO

	Demo of	miscellaneous chart graphic functions

	Copyright 1990, Prolog Development Center.

=====================================================================
*/

include "TDOMS.PRO"
include "TPREDS.PRO"

include "BGI.PRE"

include "GRAPHICS\\GRAPH.PRE"
include "GRAPHICS\\GRAPH.PRO"

include "GRAPHICS\\CHART.PRE"
include "GRAPHICS\\CHART.PRO"
include "GRAPHICS\\BGIFIND.PRO"



PREDICATES

	show_drawings
	key_scroll
	key_wait
		

GOAL	bgi_find(Bgi_Path),
	trap(initgraph(3,0,_,_,BGI_PATH),Err, no_bgi_err(Err)),
	setbkcolor(6),
	getmaxx(AbsRight), 
	Half = AbsRight / 2 - 1,
	make_Gwindow(1,23,23," Line Chart ",0,0,130,Half),
	make_Gwindow(2,23,23," Bar Chart ",0,Half,130,Half),
        make_Gwindow(3,80,10,"",132,0,38,AbsRight),
	make_Gwindow(4,80,23," SPACE BAR MESSAGE ",172,0,26,AbsRight),
	show_drawings, 
	key_wait, 
	closegraph.


DATABASE - scoll_line

	scroll_line_(string)

CLAUSES

	show_drawings :-
		shift_Gwindow(1),
		make_scale(1,0,100,0,50),
		make_axes(1,marker_(10,"%",2,15,4),marker_(10,"%3",12,15,9),
			10,15,45,90), 
		draw_axes(1),
		sample1_chart_(Sample1), chart_line(Sample1,2,2,12,11),
		sample2_chart_(Sample2), chart_line(Sample2,2,4,13,10),
		shift_Gwindow(2), make_scale(2,0,215,0,100),
		make_axes(2,marker_(19,"%",1,1,1),marker_(10,"%3",5,7,4),
			15,25,90,200), 
		draw_axes(2),
		sample_bars_(Bars), 
		chart_bar(Bars),
		shift_Gwindow(3), 
		setcolor(7),
		show_text([
	"This demo includes predicates which show the flexibility of the PDC Prolog",
	"Toolbox's charting capabilities. These predicates, like all those found",
	"in the toobox, are scaled and relative to a given window. They can show",
	"data in line chart, bar chart and pie chart forms."]),
		key_wait, 
		remove_Gwindow(1), 
		remove_Gwindow(2),
		getmaxx(AbsRight),
		make_Gwindow(1,23,23," Pie Chart ",0,0,130,AbsRight),
		make_scale(5,0,640,0,200),
		shift_scale(5),
		sample_pie_(SamplePie), !,
		chart_pie(100,75,SamplePie).


	scroll_line_("Press the space bar to continue.   ").


	key_wait :- 
		shift_Gwindow(4), 
		key_scroll.

	key_scroll :- 
		keypressed, 
		!, 
		readkey(_).
	key_scroll :- 
		retract(scroll_line_(Old)), !,
	   	frontstr(1,Old,Front,Rest),
   		concat(Rest,Front,New),
	   	assert(scroll_line_(New)),
	   	settextjustify(1,1), sleep(11),
	   	getmaxx(XMax), Middle = XMax / 2,
	   	setcolor(5), 
	   	outtextxy(Middle,8,Old),
   		setcolor(11), 
   		outtextxy(Middle,8,New),
   		key_scroll.

