/*
=====================================================================
	XDIAL.PRO

	Example of manipulating a dial with the scroll bar.
	The program also shows how messages are passed to the
	objects on the screen.

	Copyright (C) 1990 Prolog Development Center
=====================================================================
*/

code=3000
CONSTANTS


include "BGI.PRE"

include "MOUSE\\MOUSE.PRE"
include "MOUSE\\MOUSE.PRO"
include "MOUSE\\MUSTMOUS.PRO"

include "GRAPHICS\\OBJECTS.PRE"
include "GRAPHICS\\MESSAGE.PRE"
include "GRAPHICS\\GWINDOWS.PRE"
include "GRAPHICS\\SCROLBAR.PRE"
include "GRAPHICS\\DIALS.PRE"

include "GRAPHICS\\OBJECTS.PRO"
include "GRAPHICS\\GWINDOWS.PRO"
include "GRAPHICS\\SCROLBAR.PRO"
include "GRAPHICS\\DIALS.PRO"

include "GRAPHICS\\BGIFIND.PRO"



PREDICATES

	mouse_press(Integer,Integer,Integer)

CLAUSES

	message(sbar(Selector),mousepressed(MouseX,MouseY,_)) :- !,
		sbar_mousepress(Selector,MouseX,MouseY).
	message(sbar(Selector),redraw) :- !,
		sbar_Redraw(Selector).
	message(sbar(Selector),set(_,Value,_)) :- !,
		sbar_set(Selector,Value).

	message(dial(Selector),mousepressed(_,_,_)) :- !,
		dial_mousepress(Selector).
	message(dial(Selector),redraw) :- !,
		dial_Redraw(Selector).
	message(dial(Selector),set(_,Value,_)) :- !,
		dial_set(Selector,Value).


	mouse_press(X,_,_) :- X > 400, !.   % Exit if mouse X is > 400
	mouse_press(X,Y,Button) :-
		message(sBar(1),mousepressed(X,Y,Button)), !,
		fail.
	mouse_press(X,Y,Button) :-
		message(dial(1),mousepressed(X,Y,Button)), !,
		fail.


GOAL	
	must_have_mouse,
	bgi_find(BGI_PATH),	
	trap(initgraph(detect,0,_,_,BGI_PATH),Err, no_bgi_err(Err)),
	sBar_Create(Bar,vert,region(50,10,65,155),style(7,1,9),10),
	dial_Create(Dial,pedal,200,70,5,0,100,25,"Pedal Dial",
		[band(blue,25,50),band(green,50,75),band(red,75,100)]),
	sBar_Install_WhenSet(Bar,dial(Dial),0),
	dial_Redraw(Dial),
	repeat, 
		mouse_get(X,Y,Button), 
		Button >< 0,
	mouse_press(X,Y,Button),
	closegraph.

