/*
=====================================================================
	XGRAPH.PRO

	Demo of	miscellaneous extended graphic functions

	Copyright (C) 1990 Prolog Development Center.
=====================================================================
*/


include "BGI.PRE"

include "GRAPHICS\\GRAPH.PRE"
include "GRAPHICS\\GRAPH.PRO"

include "GRAPHICS\\BGIFIND.PRO"

PREDICATES

	show_drawings
	random_points(Integer)
	key_wait
	key_scroll
	

GOAL	
	bgi_find(Bgi_Path),
	trap(initgraph(detect,0,_,_,BGI_PATH),Err, no_bgi_err(Err)),
	setwritemode(0),
	getmaxx(AbsRight), 
	Half = AbsRight / 2 - 1,
	make_Gwindow(1,64,23," First Geometric Display Window ",
		5,0,125,AbsRight),
        make_Gwindow(2,80,10,"",132,0,38,AbsRight),
	make_Gwindow(4,80,23," SPACE BAR MESSAGE ",172,0,26,AbsRight),
	show_drawings, 
	key_wait, 
	remove_Gwindow(1),
	make_Gwindow(1,96,23," Second Geometric Display Window ",
		5,0,125,Half),
	show_drawings, 
	key_wait, 
	remove_Gwindow(1),
	make_Gwindow(1,46,23," Third Geometric Display Window ",
		5,0,75,AbsRight),
	show_drawings, 
	key_wait, 
	closegraph.


DATABASE - scoll_line

	scroll_line_(string)

CLAUSES

	show_drawings :-
		make_scale(1,0,2000,0,1000),
		shift_Gwindow(1),
		random_points(200), 
		setcolor(12),
		draw_line(0,0,1000,1000),
		draw_line(1000,0,0,1000),
		setfillstyle(4,9),
		draw_ellipse(1000,500,200,200),
		draw_line(1000,0,2000,1000),
		draw_line(2000,0,1000,1000),
		shift_Gwindow(2), 
		setcolor(7),
		show_text([
	"This demo includes predicates which may be used to draw all kinds",
	"of graphic images. Single points may be drawn in many types and may",
	"be drawn in a size specified by you. Lines can be drawn inside any",
	"window. The window coordinates are scaled automatically."]),
		key_wait, shift_Gwindow(1),
		setcolor(10), 
		setfillstyle(8,2), 
		draw_bar(0,0,500,1000),
		setcolor(11), 
		setfillstyle(8,2), 
		draw_bar(1500,0,2000,1000),
		setcolor(14), 
		setfillstyle(1,3), 
		draw_bar(750,250,1250,750),
		shift_Gwindow(1),
		setfillstyle(2,12),
		draw_ellipse(500,500,400,400),
		draw_ellipse(1500,500,400,400),
		setfillstyle(11,11),
		draw_pie(500,500,270,360,500),
		draw_pie(500,500,90,180,500),
		draw_pie(1500,500,180,270,500),
		draw_pie(1500,500,0,90,500),
		shift_Gwindow(2), setcolor(7),
		show_text([
	"The graphics predicates provide you with the power to draw many",
	"geometrical shapes: circles, ellipses, rectangles, pie slices,",
	"etc. Each may be colored and filled as you please. But of even more",
	"importance, coordinates are scaled to the window and active scales."]).


	random_points(0) :- !.
	random_points(Count) :- 
	 	random(7,Type),
		random(14,Color), 
		setcolor(Color),
		random(2000,X), 
		random(1000,Y),
		draw_point(X,Y,2,Type),
		Next = Count - 1, !,
		random_points(Next).
		

	scroll_line_("Press the space bar to continue.   ").


	key_wait :- 
		shift_Gwindow(4), 
		key_scroll.


	key_scroll :- 
		keypressed, 
		!, 
		readchar(_).

	key_scroll :- 
		retract(scroll_line_(Old)), !,
	   	frontstr(1,Old,Front,Rest),
   		concat(Rest,Front,New),
	   	assert(scroll_line_(New)),
	   	settextjustify(1,1), 
	   	sleep(11),
	   	getmaxx(XMax), 
	   	Middle = XMax / 2,
	   	setcolor(5), 
	   	outtextxy(Middle,8,Old),
   		setcolor(11), 
   		outtextxy(Middle,8,New),
   		key_scroll.

