/*
===========================================================================
	XHELP.PRO

	Demo of context sensitive help facilies
          (In order to run this program you must define some help texts
          using HELPDEF.PRO and save them in the help file XHELP.DEF ) 

	Copyright (C) 1990 Prolog Development Center
===========================================================================
*/

CONSTANTS
  help_inuse = true   /* enable help in tools */

include "ui\\help.pro"
include "ui\\menu.pro"
include "ui\\status.pro"

DOMAINS
  FILE = helpfile

PREDICATES
  myconsult(STRING)
  nondeterm repfile(FILE)

CLAUSES
  myconsult(FILE):-
	openread(helpfile,FILE),
	readdevice(helpfile),
	repfile(helpfile),
	readterm(help,T),
	assert(T),
	fail.
  myconsult(_):-closefile(helpfile).

  repfile(_).
  repfile(F):-
  	not(eof(F)),
  	repfile(F).

GOAL	
	textmode(ROWS,COLS),
	ROWS1=ROWS-1,
	makewindow(1,32,0,"",0,0,ROWS1,COLS),
	makestatus(112,
	   " Press F1 if you need help,  esc to proceed to the next menu"),
	assert(helpfile("xhelp.hlp")),
	myconsult("xhelp.def"),
	push_helpcontext(help1),
	menu(10,10,7,66,[first,second,third,fourth],"first menu",0,_),
	push_helpcontext(help2),
	refreshstatus,
	menu(10,10,7,66,[five,six,seven],"second menu",0,_),
	pop_helpcontext,
	refreshstatus,
	menu(10,10,7,66,[eight,nine,ten],"third menu",0,_).
