/*
==========================================================================
	XLONGMNU.PRO

	Demo of	longmenu
	
	Copyright (C) 1990 Prolog Development Center
===========================================================================
*/

check_determ

include "ui\\longmenu.pro"
include "ui\\status.pro"

Predicates
  test
  three_choices(STRINGLIST,INTEGER,INTEGER,INTEGER)
  nondeterm for(INTEGER,INTEGER,INTEGER)
  nondeterm str(STRING)

CLAUSES
  for(X,X,_).
  for(I,A,B):-B>A,A1=A+1,for(I,A1,B).

  str(first).
  str(second).
  str(third).
  str(S):-for(I,4,50),str_int(S,I).

  three_choices(L,CH1,CH2,CH3):-
	changestatus(
   "Lmenu_repeat: make one selection from each menu CR:Select Esc:previous menu"),
	longmenu_repeat(5,0,5,7,66,L,first,1,CH1),
	longmenu_repeat(10,20,5,7,71,L,second,22,CH2),
	longmenu_repeat(15,40,5,7,36,L,third,33,CH3),
	!,removewindow,removewindow,removewindow.

  test:-
	changestatus(
   "Lmenu is used to select from more than 23 alternatives  CR:Select  Esc:abort"),
	findall(X,str(X),L),
	longmenu(10,10,5,7,66,L,"longmenu",10,CHOICE),
	write("Last time you chose: ",CHOICE),nl,fail.

  test:-
	changestatus(
    "longmenu with pre-selected starting point for the cursor  CR:Select  Esc:abort"),
	findall(X,str(X),L),
	longmenu(10,10,5,7,66,L,"longmenu",3,CHOICE),
	write("Last time you chose: ",CHOICE),nl,fail.

  test:-
	changestatus(
    "Using longmenu to Create an unframed menu  CR:Select   Esc:abort"),
	findall(X,str(X),L),
	longmenu(10,10,5,112,0,L,"This message will not be visible",20,CHOICE),
	write("Last time you chose: ",CHOICE),nl,fail.

  test:-
	changestatus(
    "Lmenu_repeat: make one selection from each menu displayed  CR:Select Esc:previous menu"),
	findall(X,str(X),L),
	three_choices(L,CH1,CH2,CH3),
	write("Last time you chose: ",CH1,", ",CH2,", ",CH3),nl,
	fail.

  test:-
	changestatus(
    "Longmenu_mult allows multiple selections  F10:End  CR:(Un)select  Esc:abort"),
	findall(X,str(X),L),
	longmenu_mult(10,10,5,7,66,L,"test",[2],CHOICEL),
	write("Last time you chose: ",CHOICEL),nl,fail.
  test.

GOAL
	textmode(ROWS,COLS),ROWS1=ROWS-1,
	makewindow(1,32,0,"test",0,0,ROWS1,COLS),
	write("Use cursor keys to inspect the rest of the menu items\n\n"),
	makestatus(112,"Choose a number"),
	test,
	changestatus("End of demo").
