/*
==========================================================================
	XLOTUS.PRO

	Access a Lotus .WKS (123 & Symphony) compatible file
	from Prolog.
	
	We are using the file "xlotus.wrk" for this demo program.

	Copyright (C) 1990 Prolog Development Center
===========================================================================
*/

DOMAINS
  File	= fp

include	"import\\readext.pro"
include	"import\\lotus.pro"

PREDICATES

  /* Listing */
  list_Recs(Integer,LotusRecL)
  list_Rec(Integer,Integer,LotusRec)
  wr_Version(Integer)
  wr_elem(Value)
  NoofNL(Integer)
  PressAKey
  doPrompt

CLAUSES
  list_Recs(_,[]):- !.
  list_Recs(CurRow,[Rec|RecL]):-
	list_rec(CurRow,CurRow2,Rec),
	PressAKey,
	list_Recs(CurRow2,RecL).

  list_rec(CurRow,CurRow,elem(CurRow,Col,Int)) :- !,
	cursor(Row,_), 
	Col2=Col*8, 
	cursor(Row,Col2), 
	wr_elem(Int).

  list_rec(CurRow,Row,elem(Row,Col,Int)) :-!,
	NL = Row-CurRow,
	NoofNL(NL), 
	Col2=Col*8,
	cursor(Row2,_), 
	cursor(Row2,Col2), 
	wr_elem(Int).

  list_rec(CurRow,CurRow,version(V)):-
	write("\t\tVersion: "),wr_Version(V),nl.


  wr_Version(1028) :- write("Lotus 1-2-3 1.0").
  wr_Version(1029) :- write("Symphony 1.0").
  wr_Version(1030) :- write("Lotus 1-2-3 2.0  or  Symphony 1.1"). 

  wr_elem(int(I))  :- writef("%8",I).
  wr_elem(real(I)) :- writef("%8",I).
  wr_elem(label(S)):- writef("%8",S).

  NoofNL(N) :- N<=0,!.
  NoofNL(N) :- nl, N2=N-1, NoofNL(N2).


  PressAKey :-
	makewindow(_,_,_,_,MinR,_,NoofR,_),
	cursor(R,_), R<=MinR+NoofR-4,!.
  PressAKey :- doPrompt,cursor(R,C), scroll(R,0),cursor(0,C).

  doPrompt:-
	makewindow(Nr,Att,_,_,MinR,MinC,NoofR,NoofC),
	MinR2=MinR+NoofR-1, MinC2=MinC+NoofC/3+1,
	str_len(" Press a key",Len), Len2=Len+1, bitxor(Att,8,Att2),
	makewindow(Nr,Att2,0,"",MinR2,MinC2,1,Len2),
	write(" Press a key"), 
	readdevice(FP), 
		readdevice(keyboard), readchar(_), 
	readdevice(FP),
	removewindow.
	

/*************************************************************
		Goal
*************************************************************/
 		
GOAL	
	openread(fp,"xlotus.wrk"), readdevice(fp), filemode(fp,0),
	
	/* Read all records at once */
	rd_LotusFile(RecL),
	makewindow(85,40,36," Lotus 1-2-3 & Symphony (tm) - All Records ",0,0,25,80),
	write("\n\n",RecL), doPrompt,

	/* Read sequential, searching for specific record */
	filepos(fp,0,0),
	write("\n\nSearch for a record at column 0"),
	rd_Lotuscell(elem(Row,0,R)), Elem1=elem(Row,0,R),
	write(", Record: ",Elem1),

	write("\n\nSearch for a record at row 3 and column 3"),
	rd_Lotuscell(elem(3,3,R2)), Elem2=elem(3,3,R2),
	write(", Record: ",Elem2),
	doPrompt,
	removewindow,

	/* List records in "Spreadsheet" format */
	makewindow(85,26,36," Lotus 1-2-3 & Symphony (tm) ",0,0,25,80),
	list_recs(0,RecL),
	doPrompt,
	removewindow.
	
