/*
==========================================================================
 	XMADDER.PRO					 
  									 
  	Demo of screen handler: simple adding machine with memory	 
  	facility.							 
  									 
	Copyright (C) 1990 Prolog Development Center
===========================================================================
*/

check_determ

/************************************************************************
 *			Domains						*
 ************************************************************************/

include "tdoms.pro"

DOMAINS
  FIELD_NAME	= SYMBOL
  TYPE		= int(); str(); real()


/************************************************************************
 *			Database Predicates				*
 ************************************************************************/

DATABASE
  field(FIELD_NAME, TYPE, ROW, COL, LEN)
  txtfield(ROW, COL, LEN, STRING)		
  value(FIELD_NAME, STRING)		
  windowsize(ROW, COL)
  

/************************************************************************
 *			Include Tools					*
 ************************************************************************/

include "tpreds.pro"
include "ui\\menu.pro"
include "ui\\status.pro"
include "screen\\scrhnd.pro"		% Or vscrhnd.pro

CLAUSES
/************************************************************************
 *			Field Actions					*
 ************************************************************************/

  field_action("Total"):-
	field_value("Total", TOTAL),
	retractall(value("Memory", _)),
	assert(value("Memory", TOTAL)).
  

/************************************************************************
 *			Field Values					*
 ************************************************************************/

  field_value("Total", TOTAL2) :-
	value("FirstNo", FIRST_NO1),		
	value("SecondNo", SECOND_NO1),
	!,
	str_real(FIRST_NO1, FIRST_NO2),
	str_real(SECOND_NO1, SECOND_NO2),
	TOTAL1 = FIRST_NO2 + SECOND_NO2,
	str_real(TOTAL2, TOTAL1).
  field_value("Total", TOTAL):- value("FirstNo", TOTAL), !.
  field_value("Total", TOTAL) :- value("SecondNo", TOTAL), !.
  field_value("Total", "0") :- !.

  field_value(FIELD_NAME, VALUE) :- value(FIELD_NAME, VALUE), !.


/************************************************************************
 *			No Input Fields					*
 ************************************************************************/

  noinput("Memory").
  noinput("Total").


/************************************************************************
 *			Goal						*
 ************************************************************************/

GOAL
  consult("xmadder.scr"),
  createwindow(off),
  scrhnd(off, _).

