/*
===========================================================================
	XMENU.PRO	

	Demo of	menu

	Copyright (C) 1990 Prolog Development Center
===========================================================================
*/

include "ui\\status.pro"
include "ui\\menu.pro"

Predicates
  three_choices(STRINGLIST,INTEGER,INTEGER,INTEGER)
  test

CLAUSES
  three_choices(L,CH1,CH2,CH3):-
	menu_repeat(5,0,7,66,L,first,1,CH1),
	menu_repeat(10,20,7,71,L,second,2,CH2),
	menu_repeat(15,40,7,36,L,third,3,CH3),
	!,
	removewindow,
	removewindow,
	removewindow.

  test:-
	changestatus("Normal menu    Cr:Select    Esc:abort"),
	menu(10,10,7,66,[first,
			 second,
			 third,
			 fourth],"Normal menu",0,CHOICE),
	write("You chose: ",CHOICE),
	nl,
	fail.

  test:-
	changestatus("Normal menu with specified initial selection   Cr:Select    Esc:abort"),
	menu(10,10,7,66,[first,
			 second,
			 third,
			 fourth],"Normal menu",3,CHOICE),
	write("You chose: ",CHOICE),
	nl,
	fail.

  test:-
	changestatus("Use of menu without a frame    Cr:Select    Esc:abort"),
	menu(10,10,112,0,[first,
			  second,
			  third,
			  fourth],"No frame",2,CHOICE),
	write("You chose: ",CHOICE),
	nl,
	fail.

  test:-
	changestatus("Use of menu_repeat    Cr:Select    Esc:previous menu"),
	three_choices([first,
		       second,
		       third,
		       fourth],CH1,CH2,CH3),
	write("You chose: ",CH1,", ",CH2,", ",CH3),
	nl,
	fail.

  test:-
	changestatus("Use of menu_mult    F10: End   Cr:Select or delete   Esc:abort"),
	menu_mult(10,10,7,66,
		[first,
		 second,
		 third,
		 fourth,
		 fifth,
		 "6",
		 "7"],"test",[3,6],CHOICEL),
	write("You chose: ",CHOICEL),
	nl,
	fail.

  test.

  GOAL
	textmode(ROWS,COLS),ROWS1=ROWS-1,
	makewindow(1,32,0,"test",0,0,ROWS1,COLS),
	makestatus(112,"Choose a number"),
	test,
	changestatus("End of demo").
