/*
=========================================================================
	XPULLDW.PRO
	
	Demo of	the pulldown menu

	Note: If a pulldown curtain does not contain any selectable
	      entries (i.e consists only of bars and/or separators)
	      then it behaves as if no pulldown curtain were defined.
	
	Copyright (C) 1990 Prolog Development Center
=========================================================================
*/

include "ui\\status.pro"
include "ui\\pulldown.pro"

Database - menu_style
  frame_is(attr)

Predicates
  msg(ROW,COL,STRING)
  other_than_style_change(integer,integer)

CLAUSES
/***********************************************************************
   Pulldown tries first to call pdwaction with the windows open.	
   If no pdwaction is found, or if the found action clause fails, 
   CHOICE and SUBCHOICE are returned and the windows are removed.	
***********************************************************************/

  pdwaction(1,5):-msg(3,10,"Input 1 selected").
  pdwaction(1,7):-msg(4,10,"Input 2 selected").
  pdwaction(1,8):-msg(5,10,"Input 3 selected").
  pdwaction(2,0):-msg(5,25,"List all").
  pdwaction(3,1):-msg(3,42,"Load something").
  pdwaction(3,2):-msg(4,42,"Save something").
  pdwaction(3,4):-msg(5,42,"Delete some garbage").
  pdwaction(3,6):-msg(6,42,"Change directory").
  pdwaction(4,1):-msg(3,45,"Actions with directories").
  pdwaction(4,2):-msg(4,45,"Change colors").
  pdwaction(4,3):-
  	retract(frame_is(0)),!,
  	asserta(frame_is(66)).
  pdwaction(4,3):-
  	retract(frame_is(66)),!,
  	asserta(frame_is(0)).
  	
  pdwaction(5,0):-msg(15,10,"Please press the space bar.").

  msg(R,C,S):-
	makestatus(112,"Press any key"),
	makewindow(1,32,4,"",R,C,5,30),
	window_str(S),
	readkey(_),
	removewindow,
	removestatus.


  other_than_style_change(4,3) :- !, fail.
  other_than_Style_change(_,_).


GOAL
  textmode(ROWS,COLS),
  ROWS1=ROWS-1,
  makewindow(1,23,0,"",0,0,ROWS1,COLS),
  makestatus(112," Select with arrows or use first upper case letter"),
  field_str(15,13,50,"\015 Use Setup/change menu Style to see other style"),	
  scr_attr(15,13,220),
  asserta(frame_is(0)),
  repeat,
  frame_is(Fattr),
  pulldown(66,Fattr,[
  		curtain("Input",[
  			bar,
  			bar,
  			separator("\1"),
  			bar,
  			elem("First",top_menu,top_menu),
  			bar,
  			elem("Second",top_menu,top_menu),
  			elem("Third",top_menu,top_menu),
  			bar,
  			separator("<>")
  		],32),
	    	elem("List",top_menu,quit),
            	curtain("Files",[
            		elem("Load",top_menu,sub_menu),
            		elem("Save",top_menu,sub_menu),
            		bar,
            		elem("Delete",top_menu,quit),
            		separator(""),
            		elem("dIrectory",sub_menu,sub_menu)
            	],7),
            	curtain("Setup",[
            		elem("Directories",sub_menu,sub_menu),
            		elem("Colors",sub_menu,sub_menu),
			elem("change menu Style", quit, quit)	
            	],48),
            	elem("Quit",quit,quit)
          ]
       	             ,CH,SUBCH),
    other_than_style_change(CH, SUBCH),!,   	             
    write("\n    CH = ",CH,"\n SUBCH = ",SUBCH,'\n').

