/*
=====================================================================
	XSBAR.PRO

	Demonstrates the use of scroll bars and messages to an
	object. We poll the mouse and respond by passing a
	message to the scroll bar object.
	
	Copyright (C) 1990 Prolog Development Center
=====================================================================
*/

include "BGI.PRE"

include "MOUSE\\MOUSE.PRE"
include "GRAPHICS\\OBJECTS.PRE"
include "GRAPHICS\\MESSAGE.PRE"
include "GRAPHICS\\GWINDOWS.PRE"
include "GRAPHICS\\SCROLBAR.PRE"

include "MOUSE\\MOUSE.PRO"
include "GRAPHICS\\OBJECTS.PRO"
include "GRAPHICS\\GWINDOWS.PRO"
include "GRAPHICS\\SCROLBAR.PRO"

include "MOUSE\\MUSTMOUS.PRO"
include "GRAPHICS\\BGIFIND.PRO"

CONSTANTS
  dummy_value=999

PREDICATES

	mouse_press(Integer,Integer,Integer)

CLAUSES

	message(sbar(Selector),mousepressed(MouseX,MouseY,_)) :- !,
		sbar_mousepress(Selector,MouseX,MouseY).
	message(sbar(Selector),redraw) :- !,
		sbar_Redraw(Selector).
	message(sbar(dummy_value),set(_,Value,Max)) :- !,
		%% normally this is a message sent to another object
		Pct=(Value/Max)*100,
		format(Text,
		  "Scroll bar value: %-3  (%-6.2 Percent)", Value,Pct),
		textwidth(Text,Wide), BX=100+Wide,
		textheight(Text, High),BY=50+High,
		setfillstyle(solid_fill,black),
		bar(100,50, BX, BY),
		outtextxy(100,50,Text).

	mouse_press(X,_,_) :- X > 100, !.  % Exit if mouse X is > 100
	mouse_press(X,Y,Button) :-
		message(sBar(1),mousepressed(X,Y,Button)), !,
		fail.


GOAL	
	textmode(SaveRows,SaveCols),
	must_have_mouse,
	bgi_find(BGI_PATH),
	trap(initgraph(detect,0,_,_,BGI_PATH),Err, no_bgi_err(Err)),
	getmaxy(MaxY), 
	BarBottom = trunc( 0.9 * MaxY),
	line(100,60,100,Barbottom), 
	Ty = 60 + (Barbottom-60)/2,
	outtextxy(110,Ty, "Click over here to exit"),
	sBar_Create(BarSel,vert,region(50,15,65,BarBottom),style(7,1,9),10),
	sBar_Install_WhenSet(BarSel,sbar(dummy_value),0),
	repeat, 
		mouse_get(X,Y,Button), 
		Button >< 0,
		mouse_press(X,Y,Button),
	closegraph,
	textmode(SaveRows,SaveCols).

