/*
===========================================================================
	XVIRTUAL.PRO
  
	Demo of the virtual screen handler

	Copyright (C) 1990 Prolog Development Center
===========================================================================
*/


check_determ code=1500

include "tdoms.pro"

DOMAINS
  FIELD_NAME=SYMBOL
  TYPE = int(); str(); real()

DATABASE
  /* Database declarations used in scrhnd */
  screen(SYMBOL,DBASEDOM)	/* Saving different screens */
  value(FIELD_NAME,STRING)		/* value of a field */
  field(FIELD_NAME,TYPE,ROW,COL,LEN) /* Screen definition */
  txtfield(ROW,COL,LEN,STRING)
  windowsize(ROW,COL).

include "tpreds.pro"
include "ui\\menu.pro"
include "ui\\status.pro"
include "screen\\vscrhnd.pro"

CLAUSES
  /* Use default definitions for the screen predicates */
  field_action(_):-fail.
  field_value(FIELD_NAME,VAL):-value(FIELD_NAME,VAL),!.
  noinput(_):-fail.

GOAL
 	consult("xvirtual.scr"),	/* Load the screen definition */
	createwindow(on),		/* Make the window */
	makestatus(112," Type in some values"),
	scrhnd(on,_).			/* Call screen handler */
